/* ListView.c generated by valac 0.56.3, the Vala compiler
 * generated from ListView.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include "budgiemenuapplet.h"
#include <gtk/gtk.h>
#include <gio/gio.h>
#include "budgie-appindexer.h"
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>

#define APPLICATION_LIST_VIEW_HEIGHT 510

enum  {
	APPLICATION_LIST_VIEW_0_PROPERTY,
	APPLICATION_LIST_VIEW_SETTINGS_PROPERTY,
	APPLICATION_LIST_VIEW_NUM_PROPERTIES
};
static GParamSpec* application_list_view_properties[APPLICATION_LIST_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
typedef struct _Block2Data Block2Data;
typedef struct _Block3Data Block3Data;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _ApplicationListViewPrivate {
	GtkBox* categories;
	GtkListBox* applications;
	GtkScrolledWindow* categories_scroll;
	GtkScrolledWindow* content_scroll;
	CategoryButton* all_categories;
	GSettings* _settings;
	BudgieCategory* current_category;
	gboolean compact_mode;
	gboolean headers_visible;
	gboolean show_control_center_panels;
	gboolean rollover_menus;
	gboolean reloading;
	GRecMutex __lock_reloading;
};

struct _Block1Data {
	int _ref_count_;
	ApplicationListView* self;
	BudgieAppIndex* app_tracker;
};

struct _Block2Data {
	int _ref_count_;
	ApplicationListView* self;
	CategoryButton* btn;
};

struct _Block3Data {
	int _ref_count_;
	Block2Data * _data2_;
	BudgieApplication* app;
};

static gint ApplicationListView_private_offset;
static gpointer application_list_view_parent_class = NULL;
static GType application_list_view_type_id = 0;

static void application_list_view_real_refresh (ApplicationView* base,
                                         BudgieAppIndex* app_tracker);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean __lambda7_ (Block1Data* _data1_);
static void application_list_view_load_menus (ApplicationListView* self,
                                       BudgieAppIndex* app_tracker);
static gboolean ___lambda7__gsource_func (gpointer self);
static gboolean application_list_view_on_mouse_enter (ApplicationListView* self,
                                               GtkWidget* source_widget,
                                               GdkEventCrossing* e);
static gboolean _application_list_view_on_mouse_enter_gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                                              GdkEventCrossing* event,
                                                                              gpointer self);
static void __lambda8_ (ApplicationListView* self);
static void application_list_view_update_category (ApplicationListView* self,
                                            CategoryButton* btn);
static void ___lambda8__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                            gpointer self);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void ____lambda9_ (Block2Data* _data2_);
static void _____lambda9__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                              gpointer self);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void ______lambda10_ (Block3Data* _data3_);
static void _______lambda10__gtk_button_clicked (GtkButton* _sender,
                                          gpointer self);
static void application_list_view_real_invalidate (ApplicationView* base);
static void application_list_view_real_on_search_entry_activated (ApplicationView* base);
static void application_list_view_on_settings_changed (ApplicationListView* self,
                                                const gchar* key);
static void application_list_view_do_list_header (ApplicationListView* self,
                                           GtkListBoxRow* before,
                                           GtkListBoxRow* after);
static void _application_list_view_do_list_header_gtk_list_box_update_header_func (GtkListBoxRow* row,
                                                                            GtkListBoxRow* before,
                                                                            gpointer self);
static void application_list_view_on_row_activate (ApplicationListView* self,
                                            GtkListBoxRow* row);
static gboolean application_list_view_do_filter_list (ApplicationListView* self,
                                               GtkListBoxRow* row);
static gint application_list_view_do_sort_list (ApplicationListView* self,
                                         GtkListBoxRow* row1,
                                         GtkListBoxRow* row2);
static void application_list_view_real_on_show (ApplicationView* base);
static GObject * application_list_view_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties);
static void _application_list_view___lambda11_ (ApplicationListView* self);
static void __application_list_view___lambda11__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                    gpointer self);
static void _application_list_view_on_row_activate_gtk_list_box_row_activated (GtkListBox* _sender,
                                                                        GtkListBoxRow* row,
                                                                        gpointer self);
static void _application_list_view_on_settings_changed_g_settings_changed (GSettings* _sender,
                                                                    const gchar* key,
                                                                    gpointer self);
static gboolean _application_list_view_do_filter_list_gtk_list_box_filter_func (GtkListBoxRow* row,
                                                                         gpointer self);
static gint _application_list_view_do_sort_list_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                 GtkListBoxRow* row2,
                                                                 gpointer self);
static void application_list_view_finalize (GObject * obj);
static void _vala_application_list_view_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_application_list_view_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);

static inline gpointer
application_list_view_get_instance_private (ApplicationListView* self)
{
	return G_STRUCT_MEMBER_P (self, ApplicationListView_private_offset);
}

ApplicationListView*
application_list_view_construct (GType object_type,
                                 GSettings* settings)
{
	ApplicationListView * self = NULL;
#line 40 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_val_if_fail (settings != NULL, NULL);
#line 41 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self = (ApplicationListView*) g_object_new (object_type, "settings", settings, "orientation", GTK_ORIENTATION_HORIZONTAL, "spacing", 0, NULL);
#line 40 "../src/panel/applets/budgie-menu/views/ListView.vala"
	return self;
#line 173 "ListView.c"
}

ApplicationListView*
application_list_view_new (GSettings* settings)
{
#line 40 "../src/panel/applets/budgie-menu/views/ListView.vala"
	return application_list_view_construct (TYPE_APPLICATION_LIST_VIEW, settings);
#line 181 "ListView.c"
}

/**
 * Refreshes the category and application lists.
 */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 123 "../src/panel/applets/budgie-menu/views/ListView.vala"
	return self ? g_object_ref (self) : NULL;
#line 192 "ListView.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 123 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 123 "../src/panel/applets/budgie-menu/views/ListView.vala"
	return _data1_;
#line 202 "ListView.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 123 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 212 "ListView.c"
		ApplicationListView* self;
#line 123 "../src/panel/applets/budgie-menu/views/ListView.vala"
		self = _data1_->self;
#line 123 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (_data1_->app_tracker);
#line 123 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (self);
#line 123 "../src/panel/applets/budgie-menu/views/ListView.vala"
		g_slice_free (Block1Data, _data1_);
#line 222 "ListView.c"
	}
}

static gboolean
__lambda7_ (Block1Data* _data1_)
{
	ApplicationListView* self;
	gboolean result;
#line 144 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self = _data1_->self;
#line 145 "../src/panel/applets/budgie-menu/views/ListView.vala"
	application_list_view_load_menus (self, _data1_->app_tracker);
#line 146 "../src/panel/applets/budgie-menu/views/ListView.vala"
	application_view_invalidate ((ApplicationView*) self);
#line 147 "../src/panel/applets/budgie-menu/views/ListView.vala"
	result = FALSE;
#line 147 "../src/panel/applets/budgie-menu/views/ListView.vala"
	return result;
#line 241 "ListView.c"
}

static gboolean
___lambda7__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda7_ (self);
#line 144 "../src/panel/applets/budgie-menu/views/ListView.vala"
	return result;
#line 251 "ListView.c"
}

static void
application_list_view_real_refresh (ApplicationView* base,
                                    BudgieAppIndex* app_tracker)
{
	ApplicationListView * self;
	Block1Data* _data1_;
	BudgieAppIndex* _tmp0_;
	GtkListBox* _tmp1_;
	GList* _tmp2_;
	GHashTable* _tmp4_;
	GHashTable* _tmp5_;
	GeeArrayList* _tmp6_;
	GeeArrayList* _tmp7_;
	GtkBox* _tmp8_;
	GList* _tmp9_;
	GError* _inner_error0_ = NULL;
#line 123 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self = (ApplicationListView*) base;
#line 123 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_if_fail (app_tracker != NULL);
#line 123 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 123 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_data1_->_ref_count_ = 1;
#line 123 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_data1_->self = g_object_ref (self);
#line 123 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp0_ = _g_object_ref0 (app_tracker);
#line 123 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (_data1_->app_tracker);
#line 123 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_data1_->app_tracker = _tmp0_;
#line 286 "ListView.c"
	{
#line 124 "../src/panel/applets/budgie-menu/views/ListView.vala"
		g_rec_mutex_lock (&self->priv->__lock_reloading);
#line 290 "ListView.c"
		{
#line 125 "../src/panel/applets/budgie-menu/views/ListView.vala"
			if (self->priv->reloading) {
#line 294 "ListView.c"
				{
#line 124 "../src/panel/applets/budgie-menu/views/ListView.vala"
					g_rec_mutex_unlock (&self->priv->__lock_reloading);
#line 298 "ListView.c"
				}
#line 126 "../src/panel/applets/budgie-menu/views/ListView.vala"
				block1_data_unref (_data1_);
#line 126 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_data1_ = NULL;
#line 126 "../src/panel/applets/budgie-menu/views/ListView.vala"
				return;
#line 306 "ListView.c"
			}
#line 128 "../src/panel/applets/budgie-menu/views/ListView.vala"
			self->priv->reloading = TRUE;
#line 310 "ListView.c"
		}
		__finally0:
		{
#line 124 "../src/panel/applets/budgie-menu/views/ListView.vala"
			g_rec_mutex_unlock (&self->priv->__lock_reloading);
#line 316 "ListView.c"
		}
#line 124 "../src/panel/applets/budgie-menu/views/ListView.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 124 "../src/panel/applets/budgie-menu/views/ListView.vala"
			block1_data_unref (_data1_);
#line 124 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_data1_ = NULL;
#line 124 "../src/panel/applets/budgie-menu/views/ListView.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 124 "../src/panel/applets/budgie-menu/views/ListView.vala"
			g_clear_error (&_inner_error0_);
#line 124 "../src/panel/applets/budgie-menu/views/ListView.vala"
			return;
#line 330 "ListView.c"
		}
	}
#line 132 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp1_ = self->priv->applications;
#line 132 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp2_ = gtk_container_get_children ((GtkContainer*) _tmp1_);
#line 337 "ListView.c"
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
#line 132 "../src/panel/applets/budgie-menu/views/ListView.vala"
		child_collection = _tmp2_;
#line 132 "../src/panel/applets/budgie-menu/views/ListView.vala"
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
#line 345 "ListView.c"
			GtkWidget* child = NULL;
#line 132 "../src/panel/applets/budgie-menu/views/ListView.vala"
			child = (GtkWidget*) child_it->data;
#line 349 "ListView.c"
			{
				GtkWidget* _tmp3_;
#line 133 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_tmp3_ = child;
#line 133 "../src/panel/applets/budgie-menu/views/ListView.vala"
				gtk_widget_destroy (_tmp3_);
#line 356 "ListView.c"
			}
		}
#line 132 "../src/panel/applets/budgie-menu/views/ListView.vala"
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 361 "ListView.c"
	}
#line 135 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp4_ = application_view_get_application_buttons ((ApplicationView*) self);
#line 135 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp5_ = _tmp4_;
#line 135 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_hash_table_remove_all (_tmp5_);
#line 136 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp6_ = application_view_get_control_center_buttons ((ApplicationView*) self);
#line 136 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp7_ = _tmp6_;
#line 136 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp7_);
#line 139 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp8_ = self->priv->categories;
#line 139 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp9_ = gtk_container_get_children ((GtkContainer*) _tmp8_);
#line 379 "ListView.c"
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
#line 139 "../src/panel/applets/budgie-menu/views/ListView.vala"
		child_collection = _tmp9_;
#line 139 "../src/panel/applets/budgie-menu/views/ListView.vala"
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
#line 387 "ListView.c"
			GtkWidget* child = NULL;
#line 139 "../src/panel/applets/budgie-menu/views/ListView.vala"
			child = (GtkWidget*) child_it->data;
#line 391 "ListView.c"
			{
				GtkWidget* _tmp10_;
#line 140 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_tmp10_ = child;
#line 140 "../src/panel/applets/budgie-menu/views/ListView.vala"
				gtk_widget_destroy (_tmp10_);
#line 398 "ListView.c"
			}
		}
#line 139 "../src/panel/applets/budgie-menu/views/ListView.vala"
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 403 "ListView.c"
	}
#line 144 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda7__gsource_func, block1_data_ref (_data1_), block1_data_unref);
#line 407 "ListView.c"
	{
#line 150 "../src/panel/applets/budgie-menu/views/ListView.vala"
		g_rec_mutex_lock (&self->priv->__lock_reloading);
#line 411 "ListView.c"
		{
#line 151 "../src/panel/applets/budgie-menu/views/ListView.vala"
			self->priv->reloading = FALSE;
#line 415 "ListView.c"
		}
		__finally1:
		{
#line 150 "../src/panel/applets/budgie-menu/views/ListView.vala"
			g_rec_mutex_unlock (&self->priv->__lock_reloading);
#line 421 "ListView.c"
		}
#line 150 "../src/panel/applets/budgie-menu/views/ListView.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 150 "../src/panel/applets/budgie-menu/views/ListView.vala"
			block1_data_unref (_data1_);
#line 150 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_data1_ = NULL;
#line 150 "../src/panel/applets/budgie-menu/views/ListView.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 150 "../src/panel/applets/budgie-menu/views/ListView.vala"
			g_clear_error (&_inner_error0_);
#line 150 "../src/panel/applets/budgie-menu/views/ListView.vala"
			return;
#line 435 "ListView.c"
		}
	}
#line 123 "../src/panel/applets/budgie-menu/views/ListView.vala"
	block1_data_unref (_data1_);
#line 123 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_data1_ = NULL;
#line 442 "ListView.c"
}

/**
 * Build the category and application lists.
 */
static gboolean
_application_list_view_on_mouse_enter_gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                                     GdkEventCrossing* event,
                                                                     gpointer self)
{
	gboolean result;
	result = application_list_view_on_mouse_enter ((ApplicationListView*) self, _sender, event);
#line 161 "../src/panel/applets/budgie-menu/views/ListView.vala"
	return result;
#line 457 "ListView.c"
}

static void
__lambda8_ (ApplicationListView* self)
{
	CategoryButton* _tmp0_;
#line 163 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp0_ = self->priv->all_categories;
#line 163 "../src/panel/applets/budgie-menu/views/ListView.vala"
	application_list_view_update_category (self, _tmp0_);
#line 468 "ListView.c"
}

static void
___lambda8__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                       gpointer self)
{
#line 162 "../src/panel/applets/budgie-menu/views/ListView.vala"
	__lambda8_ ((ApplicationListView*) self);
#line 477 "ListView.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 167 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 167 "../src/panel/applets/budgie-menu/views/ListView.vala"
	return _data2_;
#line 487 "ListView.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 167 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 497 "ListView.c"
		ApplicationListView* self;
#line 167 "../src/panel/applets/budgie-menu/views/ListView.vala"
		self = _data2_->self;
#line 167 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (_data2_->btn);
#line 167 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (self);
#line 167 "../src/panel/applets/budgie-menu/views/ListView.vala"
		g_slice_free (Block2Data, _data2_);
#line 507 "ListView.c"
	}
}

static void
____lambda9_ (Block2Data* _data2_)
{
	ApplicationListView* self;
	CategoryButton* _tmp0_;
#line 179 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self = _data2_->self;
#line 180 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp0_ = _data2_->btn;
#line 180 "../src/panel/applets/budgie-menu/views/ListView.vala"
	application_list_view_update_category (self, _tmp0_);
#line 522 "ListView.c"
}

static void
_____lambda9__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                         gpointer self)
{
#line 179 "../src/panel/applets/budgie-menu/views/ListView.vala"
	____lambda9_ (self);
#line 531 "ListView.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 187 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 187 "../src/panel/applets/budgie-menu/views/ListView.vala"
	return _data3_;
#line 541 "ListView.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 187 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 551 "ListView.c"
		ApplicationListView* self;
#line 187 "../src/panel/applets/budgie-menu/views/ListView.vala"
		self = _data3_->_data2_->self;
#line 187 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (_data3_->app);
#line 187 "../src/panel/applets/budgie-menu/views/ListView.vala"
		block2_data_unref (_data3_->_data2_);
#line 187 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_data3_->_data2_ = NULL;
#line 187 "../src/panel/applets/budgie-menu/views/ListView.vala"
		g_slice_free (Block3Data, _data3_);
#line 563 "ListView.c"
	}
}

static void
______lambda10_ (Block3Data* _data3_)
{
	Block2Data* _data2_;
	ApplicationListView* self;
	BudgieApplication* _tmp0_;
#line 190 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_data2_ = _data3_->_data2_;
#line 190 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self = _data2_->self;
#line 191 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp0_ = _data3_->app;
#line 191 "../src/panel/applets/budgie-menu/views/ListView.vala"
	budgie_application_launch (_tmp0_);
#line 192 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_signal_emit_by_name ((ApplicationView*) self, "app-launched");
#line 583 "ListView.c"
}

static void
_______lambda10__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self)
{
#line 190 "../src/panel/applets/budgie-menu/views/ListView.vala"
	______lambda10_ (self);
#line 592 "ListView.c"
}

static void
application_list_view_load_menus (ApplicationListView* self,
                                  BudgieAppIndex* app_tracker)
{
	CategoryButton* _tmp0_;
	CategoryButton* _tmp1_;
	CategoryButton* _tmp2_;
	GtkBox* _tmp3_;
	CategoryButton* _tmp4_;
#line 158 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_if_fail (self != NULL);
#line 158 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_if_fail (app_tracker != NULL);
#line 160 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp0_ = category_button_new (NULL);
#line 160 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_object_ref_sink (_tmp0_);
#line 160 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (self->priv->all_categories);
#line 160 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self->priv->all_categories = _tmp0_;
#line 161 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp1_ = self->priv->all_categories;
#line 161 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_signal_connect_object ((GtkWidget*) _tmp1_, "enter-notify-event", (GCallback) _application_list_view_on_mouse_enter_gtk_widget_enter_notify_event, self, 0);
#line 162 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp2_ = self->priv->all_categories;
#line 162 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_signal_connect_object ((GtkToggleButton*) _tmp2_, "toggled", (GCallback) ___lambda8__gtk_toggle_button_toggled, self, 0);
#line 165 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp3_ = self->priv->categories;
#line 165 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp4_ = self->priv->all_categories;
#line 165 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_box_pack_start (_tmp3_, (GtkWidget*) _tmp4_, FALSE, FALSE, (guint) 0);
#line 630 "ListView.c"
	{
		GeeArrayList* _category_list = NULL;
		GeeArrayList* _tmp5_;
		gint _category_size = 0;
		GeeArrayList* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gint _category_index = 0;
#line 167 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp5_ = budgie_app_index_get_categories (app_tracker);
#line 167 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_category_list = _tmp5_;
#line 167 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp6_ = _category_list;
#line 167 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
#line 167 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp8_ = _tmp7_;
#line 167 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_category_size = _tmp8_;
#line 167 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_category_index = -1;
#line 167 "../src/panel/applets/budgie-menu/views/ListView.vala"
		while (TRUE) {
#line 655 "ListView.c"
			Block2Data* _data2_;
			gint _tmp9_;
			gint _tmp10_;
			BudgieCategory* category = NULL;
			GeeArrayList* _tmp11_;
			gpointer _tmp12_;
			BudgieCategory* _tmp13_;
			GeeArrayList* _tmp14_;
			GeeArrayList* _tmp15_;
			gboolean _tmp16_;
			gboolean _tmp17_;
			BudgieCategory* _tmp18_;
			CategoryButton* _tmp19_;
			CategoryButton* _tmp20_;
			CategoryButton* _tmp21_;
			CategoryButton* _tmp22_;
			CategoryButton* _tmp23_;
			CategoryButton* _tmp24_;
			GtkBox* _tmp25_;
			CategoryButton* _tmp26_;
#line 167 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_data2_ = g_slice_new0 (Block2Data);
#line 167 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_data2_->_ref_count_ = 1;
#line 167 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_data2_->self = g_object_ref (self);
#line 167 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_category_index = _category_index + 1;
#line 167 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_tmp9_ = _category_index;
#line 167 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_tmp10_ = _category_size;
#line 167 "../src/panel/applets/budgie-menu/views/ListView.vala"
			if (!(_tmp9_ < _tmp10_)) {
#line 167 "../src/panel/applets/budgie-menu/views/ListView.vala"
				block2_data_unref (_data2_);
#line 167 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_data2_ = NULL;
#line 167 "../src/panel/applets/budgie-menu/views/ListView.vala"
				break;
#line 696 "ListView.c"
			}
#line 167 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_tmp11_ = _category_list;
#line 167 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _tmp11_, _category_index);
#line 167 "../src/panel/applets/budgie-menu/views/ListView.vala"
			category = (BudgieCategory*) _tmp12_;
#line 169 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_tmp13_ = category;
#line 169 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_tmp14_ = budgie_category_get_apps (_tmp13_);
#line 169 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_tmp15_ = _tmp14_;
#line 169 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_tmp16_ = gee_collection_get_is_empty ((GeeCollection*) _tmp15_);
#line 169 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_tmp17_ = _tmp16_;
#line 169 "../src/panel/applets/budgie-menu/views/ListView.vala"
			if (_tmp17_) {
#line 170 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_g_object_unref0 (category);
#line 170 "../src/panel/applets/budgie-menu/views/ListView.vala"
				block2_data_unref (_data2_);
#line 170 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_data2_ = NULL;
#line 170 "../src/panel/applets/budgie-menu/views/ListView.vala"
				continue;
#line 724 "ListView.c"
			}
#line 174 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_tmp18_ = category;
#line 174 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_tmp19_ = category_button_new (_tmp18_);
#line 174 "../src/panel/applets/budgie-menu/views/ListView.vala"
			g_object_ref_sink (_tmp19_);
#line 174 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_data2_->btn = _tmp19_;
#line 175 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_tmp20_ = _data2_->btn;
#line 175 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_tmp21_ = self->priv->all_categories;
#line 175 "../src/panel/applets/budgie-menu/views/ListView.vala"
			gtk_radio_button_join_group ((GtkRadioButton*) _tmp20_, (GtkRadioButton*) _tmp21_);
#line 176 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_tmp22_ = _data2_->btn;
#line 176 "../src/panel/applets/budgie-menu/views/ListView.vala"
			g_signal_connect_object ((GtkWidget*) _tmp22_, "enter-notify-event", (GCallback) _application_list_view_on_mouse_enter_gtk_widget_enter_notify_event, self, 0);
#line 179 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_tmp23_ = _data2_->btn;
#line 179 "../src/panel/applets/budgie-menu/views/ListView.vala"
			g_signal_connect_data ((GtkToggleButton*) _tmp23_, "toggled", (GCallback) _____lambda9__gtk_toggle_button_toggled, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 183 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_tmp24_ = _data2_->btn;
#line 183 "../src/panel/applets/budgie-menu/views/ListView.vala"
			gtk_widget_show_all ((GtkWidget*) _tmp24_);
#line 184 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_tmp25_ = self->priv->categories;
#line 184 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_tmp26_ = _data2_->btn;
#line 184 "../src/panel/applets/budgie-menu/views/ListView.vala"
			gtk_box_pack_start (_tmp25_, (GtkWidget*) _tmp26_, FALSE, FALSE, (guint) 0);
#line 758 "ListView.c"
			{
				GeeArrayList* _app_list = NULL;
				BudgieCategory* _tmp27_;
				GeeArrayList* _tmp28_;
				GeeArrayList* _tmp29_;
				gint _app_size = 0;
				GeeArrayList* _tmp30_;
				gint _tmp31_;
				gint _tmp32_;
				gint _app_index = 0;
#line 187 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_tmp27_ = category;
#line 187 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_tmp28_ = budgie_category_get_apps (_tmp27_);
#line 187 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_tmp29_ = _tmp28_;
#line 187 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_app_list = _tmp29_;
#line 187 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_tmp30_ = _app_list;
#line 187 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_tmp31_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp30_);
#line 187 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_tmp32_ = _tmp31_;
#line 187 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_app_size = _tmp32_;
#line 187 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_app_index = -1;
#line 187 "../src/panel/applets/budgie-menu/views/ListView.vala"
				while (TRUE) {
#line 789 "ListView.c"
					Block3Data* _data3_;
					gint _tmp33_;
					gint _tmp34_;
					GeeArrayList* _tmp35_;
					gpointer _tmp36_;
					MenuButton* app_btn = NULL;
					BudgieApplication* _tmp37_;
					BudgieCategory* _tmp38_;
					gint _tmp39_;
					gint _tmp40_;
					MenuButton* _tmp41_;
					MenuButton* _tmp42_;
					GHashTable* _tmp43_;
					GHashTable* _tmp44_;
					BudgieApplication* _tmp45_;
					const gchar* _tmp46_;
					const gchar* _tmp47_;
					gchar* _tmp48_;
					MenuButton* _tmp49_;
					MenuButton* _tmp50_;
					MenuButton* _tmp51_;
					GtkListBox* _tmp52_;
					MenuButton* _tmp53_;
					MenuButton* _tmp54_;
#line 187 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_data3_ = g_slice_new0 (Block3Data);
#line 187 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_data3_->_ref_count_ = 1;
#line 187 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_data3_->_data2_ = block2_data_ref (_data2_);
#line 187 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_app_index = _app_index + 1;
#line 187 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp33_ = _app_index;
#line 187 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp34_ = _app_size;
#line 187 "../src/panel/applets/budgie-menu/views/ListView.vala"
					if (!(_tmp33_ < _tmp34_)) {
#line 187 "../src/panel/applets/budgie-menu/views/ListView.vala"
						block3_data_unref (_data3_);
#line 187 "../src/panel/applets/budgie-menu/views/ListView.vala"
						_data3_ = NULL;
#line 187 "../src/panel/applets/budgie-menu/views/ListView.vala"
						break;
#line 834 "ListView.c"
					}
#line 187 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp35_ = _app_list;
#line 187 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp36_ = gee_abstract_list_get ((GeeAbstractList*) _tmp35_, _app_index);
#line 187 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_data3_->app = (BudgieApplication*) _tmp36_;
#line 188 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp37_ = _data3_->app;
#line 188 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp38_ = category;
#line 188 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp39_ = application_view_get_icon_size ((ApplicationView*) self);
#line 188 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp40_ = _tmp39_;
#line 188 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp41_ = menu_button_new (_tmp37_, _tmp38_, _tmp40_);
#line 188 "../src/panel/applets/budgie-menu/views/ListView.vala"
					g_object_ref_sink (_tmp41_);
#line 188 "../src/panel/applets/budgie-menu/views/ListView.vala"
					app_btn = _tmp41_;
#line 190 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp42_ = app_btn;
#line 190 "../src/panel/applets/budgie-menu/views/ListView.vala"
					g_signal_connect_data ((GtkButton*) _tmp42_, "clicked", (GCallback) _______lambda10__gtk_button_clicked, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
#line 195 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp43_ = application_view_get_application_buttons ((ApplicationView*) self);
#line 195 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp44_ = _tmp43_;
#line 195 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp45_ = _data3_->app;
#line 195 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp46_ = budgie_application_get_desktop_id (_tmp45_);
#line 195 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp47_ = _tmp46_;
#line 195 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp48_ = g_strdup (_tmp47_);
#line 195 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp49_ = app_btn;
#line 195 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp50_ = _g_object_ref0 (_tmp49_);
#line 195 "../src/panel/applets/budgie-menu/views/ListView.vala"
					g_hash_table_insert (_tmp44_, _tmp48_, _tmp50_);
#line 196 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp51_ = app_btn;
#line 196 "../src/panel/applets/budgie-menu/views/ListView.vala"
					gtk_widget_show_all ((GtkWidget*) _tmp51_);
#line 197 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp52_ = self->priv->applications;
#line 197 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp53_ = app_btn;
#line 197 "../src/panel/applets/budgie-menu/views/ListView.vala"
					gtk_container_add ((GtkContainer*) _tmp52_, (GtkWidget*) _tmp53_);
#line 199 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp54_ = app_btn;
#line 199 "../src/panel/applets/budgie-menu/views/ListView.vala"
					if (menu_button_is_control_center_panel (_tmp54_)) {
#line 892 "ListView.c"
						GeeArrayList* _tmp55_;
						GeeArrayList* _tmp56_;
						MenuButton* _tmp57_;
#line 200 "../src/panel/applets/budgie-menu/views/ListView.vala"
						_tmp55_ = application_view_get_control_center_buttons ((ApplicationView*) self);
#line 200 "../src/panel/applets/budgie-menu/views/ListView.vala"
						_tmp56_ = _tmp55_;
#line 200 "../src/panel/applets/budgie-menu/views/ListView.vala"
						_tmp57_ = app_btn;
#line 200 "../src/panel/applets/budgie-menu/views/ListView.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp56_, _tmp57_);
#line 904 "ListView.c"
					}
#line 187 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_g_object_unref0 (app_btn);
#line 187 "../src/panel/applets/budgie-menu/views/ListView.vala"
					block3_data_unref (_data3_);
#line 187 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_data3_ = NULL;
#line 912 "ListView.c"
				}
			}
#line 167 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_g_object_unref0 (category);
#line 167 "../src/panel/applets/budgie-menu/views/ListView.vala"
			block2_data_unref (_data2_);
#line 167 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_data2_ = NULL;
#line 921 "ListView.c"
		}
#line 167 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (_category_list);
#line 925 "ListView.c"
	}
}

/**
 * Invalidate the application headers, filters, and sorting.
 */
static void
application_list_view_real_invalidate (ApplicationView* base)
{
	ApplicationListView * self;
	GtkListBox* _tmp0_;
	GtkListBox* _tmp1_;
	GtkListBox* _tmp2_;
#line 209 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self = (ApplicationListView*) base;
#line 210 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp0_ = self->priv->applications;
#line 210 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_list_box_invalidate_headers (_tmp0_);
#line 211 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp1_ = self->priv->applications;
#line 211 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_list_box_invalidate_filter (_tmp1_);
#line 212 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp2_ = self->priv->applications;
#line 212 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_list_box_invalidate_sort (_tmp2_);
#line 953 "ListView.c"
}

/**
 * Launches the application selected by the current search result.
 */
static void
application_list_view_real_on_search_entry_activated (ApplicationView* base)
{
	ApplicationListView * self;
	GtkListBoxRow* selected = NULL;
	GList* rows = NULL;
	GtkListBox* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	GtkListBoxRow* _tmp13_;
	MenuButton* btn = NULL;
	GtkListBoxRow* _tmp14_;
	GtkWidget* _tmp15_;
	MenuButton* _tmp16_;
	MenuButton* _tmp17_;
	BudgieApplication* _tmp18_;
	BudgieApplication* _tmp19_;
#line 218 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self = (ApplicationListView*) base;
#line 219 "../src/panel/applets/budgie-menu/views/ListView.vala"
	selected = NULL;
#line 221 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp0_ = self->priv->applications;
#line 221 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp1_ = gtk_list_box_get_selected_rows (_tmp0_);
#line 221 "../src/panel/applets/budgie-menu/views/ListView.vala"
	rows = _tmp1_;
#line 222 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp2_ = rows;
#line 222 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (_tmp2_ != NULL) {
#line 990 "ListView.c"
		GList* _tmp3_;
		gconstpointer _tmp4_;
		GtkListBoxRow* _tmp5_;
#line 223 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp3_ = rows;
#line 223 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp4_ = _tmp3_->data;
#line 223 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp5_ = _g_object_ref0 ((GtkListBoxRow*) _tmp4_);
#line 223 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (selected);
#line 223 "../src/panel/applets/budgie-menu/views/ListView.vala"
		selected = _tmp5_;
#line 1004 "ListView.c"
	} else {
		GtkListBox* _tmp6_;
		GList* _tmp7_;
#line 225 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp6_ = self->priv->applications;
#line 225 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp7_ = gtk_container_get_children ((GtkContainer*) _tmp6_);
#line 1012 "ListView.c"
		{
			GList* child_collection = NULL;
			GList* child_it = NULL;
#line 225 "../src/panel/applets/budgie-menu/views/ListView.vala"
			child_collection = _tmp7_;
#line 225 "../src/panel/applets/budgie-menu/views/ListView.vala"
			for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
#line 1020 "ListView.c"
				GtkWidget* child = NULL;
#line 225 "../src/panel/applets/budgie-menu/views/ListView.vala"
				child = (GtkWidget*) child_it->data;
#line 1024 "ListView.c"
				{
					gboolean _tmp8_ = FALSE;
					GtkWidget* _tmp9_;
#line 226 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp9_ = child;
#line 226 "../src/panel/applets/budgie-menu/views/ListView.vala"
					if (gtk_widget_get_visible (_tmp9_)) {
#line 1032 "ListView.c"
						GtkWidget* _tmp10_;
#line 226 "../src/panel/applets/budgie-menu/views/ListView.vala"
						_tmp10_ = child;
#line 226 "../src/panel/applets/budgie-menu/views/ListView.vala"
						_tmp8_ = gtk_widget_get_child_visible (_tmp10_);
#line 1038 "ListView.c"
					} else {
#line 226 "../src/panel/applets/budgie-menu/views/ListView.vala"
						_tmp8_ = FALSE;
#line 1042 "ListView.c"
					}
#line 226 "../src/panel/applets/budgie-menu/views/ListView.vala"
					if (_tmp8_) {
#line 1046 "ListView.c"
						GtkWidget* _tmp11_;
						GtkListBoxRow* _tmp12_;
#line 227 "../src/panel/applets/budgie-menu/views/ListView.vala"
						_tmp11_ = child;
#line 227 "../src/panel/applets/budgie-menu/views/ListView.vala"
						_tmp12_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp11_, gtk_list_box_row_get_type ()) ? ((GtkListBoxRow*) _tmp11_) : NULL);
#line 227 "../src/panel/applets/budgie-menu/views/ListView.vala"
						_g_object_unref0 (selected);
#line 227 "../src/panel/applets/budgie-menu/views/ListView.vala"
						selected = _tmp12_;
#line 228 "../src/panel/applets/budgie-menu/views/ListView.vala"
						break;
#line 1059 "ListView.c"
					}
				}
			}
#line 225 "../src/panel/applets/budgie-menu/views/ListView.vala"
			(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 1065 "ListView.c"
		}
	}
#line 232 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp13_ = selected;
#line 232 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (_tmp13_ == NULL) {
#line 233 "../src/panel/applets/budgie-menu/views/ListView.vala"
		(rows == NULL) ? NULL : (rows = (g_list_free (rows), NULL));
#line 233 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (selected);
#line 233 "../src/panel/applets/budgie-menu/views/ListView.vala"
		return;
#line 1078 "ListView.c"
	}
#line 236 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp14_ = selected;
#line 236 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp15_ = gtk_bin_get_child ((GtkBin*) _tmp14_);
#line 236 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp16_ = _g_object_ref0 (IS_MENU_BUTTON (_tmp15_) ? ((MenuButton*) _tmp15_) : NULL);
#line 236 "../src/panel/applets/budgie-menu/views/ListView.vala"
	btn = _tmp16_;
#line 237 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp17_ = btn;
#line 237 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp18_ = menu_button_get_app (_tmp17_);
#line 237 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp19_ = _tmp18_;
#line 237 "../src/panel/applets/budgie-menu/views/ListView.vala"
	budgie_application_launch (_tmp19_);
#line 238 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_signal_emit_by_name ((ApplicationView*) self, "app-launched");
#line 218 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (btn);
#line 218 "../src/panel/applets/budgie-menu/views/ListView.vala"
	(rows == NULL) ? NULL : (rows = (g_list_free (rows), NULL));
#line 218 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (selected);
#line 1104 "ListView.c"
}

/**
 * Permits "rolling" over categories.
 */
static gboolean
application_list_view_on_mouse_enter (ApplicationListView* self,
                                      GtkWidget* source_widget,
                                      GdkEventCrossing* e)
{
	GtkToggleButton* b = NULL;
	GtkToggleButton* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GtkToggleButton* _tmp2_;
	GtkToggleButton* _tmp4_;
	gboolean result;
#line 244 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 244 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_val_if_fail (source_widget != NULL, FALSE);
#line 244 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 245 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (!self->priv->rollover_menus) {
#line 246 "../src/panel/applets/budgie-menu/views/ListView.vala"
		result = GDK_EVENT_PROPAGATE;
#line 246 "../src/panel/applets/budgie-menu/views/ListView.vala"
		return result;
#line 1133 "ListView.c"
	}
#line 250 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (source_widget, gtk_toggle_button_get_type ()) ? ((GtkToggleButton*) source_widget) : NULL);
#line 250 "../src/panel/applets/budgie-menu/views/ListView.vala"
	b = _tmp0_;
#line 251 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp2_ = b;
#line 251 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (!gtk_widget_get_sensitive ((GtkWidget*) _tmp2_)) {
#line 251 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp1_ = TRUE;
#line 1145 "ListView.c"
	} else {
		GtkToggleButton* _tmp3_;
#line 251 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp3_ = b;
#line 251 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp1_ = !gtk_widget_get_visible ((GtkWidget*) _tmp3_);
#line 1152 "ListView.c"
	}
#line 251 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (_tmp1_) {
#line 252 "../src/panel/applets/budgie-menu/views/ListView.vala"
		result = GDK_EVENT_PROPAGATE;
#line 252 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (b);
#line 252 "../src/panel/applets/budgie-menu/views/ListView.vala"
		return result;
#line 1162 "ListView.c"
	}
#line 256 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp4_ = b;
#line 256 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_toggle_button_set_active (_tmp4_, TRUE);
#line 257 "../src/panel/applets/budgie-menu/views/ListView.vala"
	result = GDK_EVENT_PROPAGATE;
#line 257 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (b);
#line 257 "../src/panel/applets/budgie-menu/views/ListView.vala"
	return result;
#line 1174 "ListView.c"
}

/**
 * Handles changes to our applet settings.
 */
static void
_application_list_view_do_list_header_gtk_list_box_update_header_func (GtkListBoxRow* row,
                                                                       GtkListBoxRow* before,
                                                                       gpointer self)
{
#line 276 "../src/panel/applets/budgie-menu/views/ListView.vala"
	application_list_view_do_list_header ((ApplicationListView*) self, row, before);
#line 1187 "ListView.c"
}

static void
application_list_view_on_settings_changed (ApplicationListView* self,
                                           const gchar* key)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 264 "../src/panel/applets/budgie-menu/views/ListView.vala"
	static GQuark _tmp1_label0 = 0;
#line 264 "../src/panel/applets/budgie-menu/views/ListView.vala"
	static GQuark _tmp1_label1 = 0;
#line 264 "../src/panel/applets/budgie-menu/views/ListView.vala"
	static GQuark _tmp1_label2 = 0;
#line 264 "../src/panel/applets/budgie-menu/views/ListView.vala"
	static GQuark _tmp1_label3 = 0;
#line 263 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_if_fail (self != NULL);
#line 263 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_if_fail (key != NULL);
#line 264 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp0_ = key;
#line 264 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 264 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("menu-compact")))) {
#line 264 "../src/panel/applets/budgie-menu/views/ListView.vala"
		switch (0) {
#line 1216 "ListView.c"
			default:
			{
				gboolean vis = FALSE;
				GSettings* _tmp3_;
				GtkScrolledWindow* _tmp4_;
				GtkScrolledWindow* _tmp5_;
#line 266 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_tmp3_ = self->priv->_settings;
#line 266 "../src/panel/applets/budgie-menu/views/ListView.vala"
				vis = g_settings_get_boolean (_tmp3_, key);
#line 267 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_tmp4_ = self->priv->categories_scroll;
#line 267 "../src/panel/applets/budgie-menu/views/ListView.vala"
				gtk_widget_set_no_show_all ((GtkWidget*) _tmp4_, vis);
#line 268 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_tmp5_ = self->priv->categories_scroll;
#line 268 "../src/panel/applets/budgie-menu/views/ListView.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp5_, vis);
#line 269 "../src/panel/applets/budgie-menu/views/ListView.vala"
				self->priv->compact_mode = vis;
#line 270 "../src/panel/applets/budgie-menu/views/ListView.vala"
				application_view_invalidate ((ApplicationView*) self);
#line 271 "../src/panel/applets/budgie-menu/views/ListView.vala"
				break;
#line 1241 "ListView.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("menu-headers")))) {
#line 264 "../src/panel/applets/budgie-menu/views/ListView.vala"
		switch (0) {
#line 1247 "ListView.c"
			default:
			{
				gboolean hed = FALSE;
				GSettings* _tmp6_;
#line 273 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_tmp6_ = self->priv->_settings;
#line 273 "../src/panel/applets/budgie-menu/views/ListView.vala"
				hed = g_settings_get_boolean (_tmp6_, key);
#line 274 "../src/panel/applets/budgie-menu/views/ListView.vala"
				self->priv->headers_visible = hed;
#line 275 "../src/panel/applets/budgie-menu/views/ListView.vala"
				if (hed) {
#line 1260 "ListView.c"
					GtkListBox* _tmp7_;
#line 276 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp7_ = self->priv->applications;
#line 276 "../src/panel/applets/budgie-menu/views/ListView.vala"
					gtk_list_box_set_header_func (_tmp7_, _application_list_view_do_list_header_gtk_list_box_update_header_func, g_object_ref (self), g_object_unref);
#line 1266 "ListView.c"
				} else {
					GtkListBox* _tmp8_;
#line 278 "../src/panel/applets/budgie-menu/views/ListView.vala"
					_tmp8_ = self->priv->applications;
#line 278 "../src/panel/applets/budgie-menu/views/ListView.vala"
					gtk_list_box_set_header_func (_tmp8_, NULL, NULL, NULL);
#line 1273 "ListView.c"
				}
#line 280 "../src/panel/applets/budgie-menu/views/ListView.vala"
				application_view_invalidate ((ApplicationView*) self);
#line 281 "../src/panel/applets/budgie-menu/views/ListView.vala"
				break;
#line 1279 "ListView.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("menu-categories-hover")))) {
#line 264 "../src/panel/applets/budgie-menu/views/ListView.vala"
		switch (0) {
#line 1285 "ListView.c"
			default:
			{
				GSettings* _tmp9_;
#line 284 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_tmp9_ = self->priv->_settings;
#line 284 "../src/panel/applets/budgie-menu/views/ListView.vala"
				self->priv->rollover_menus = g_settings_get_boolean (_tmp9_, key);
#line 285 "../src/panel/applets/budgie-menu/views/ListView.vala"
				break;
#line 1295 "ListView.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("menu-show-control-center-items")))) {
#line 264 "../src/panel/applets/budgie-menu/views/ListView.vala"
		switch (0) {
#line 1301 "ListView.c"
			default:
			{
				GSettings* _tmp10_;
#line 287 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_tmp10_ = self->priv->_settings;
#line 287 "../src/panel/applets/budgie-menu/views/ListView.vala"
				self->priv->show_control_center_panels = g_settings_get_boolean (_tmp10_, key);
#line 288 "../src/panel/applets/budgie-menu/views/ListView.vala"
				application_view_invalidate ((ApplicationView*) self);
#line 289 "../src/panel/applets/budgie-menu/views/ListView.vala"
				break;
#line 1313 "ListView.c"
			}
		}
	} else {
#line 264 "../src/panel/applets/budgie-menu/views/ListView.vala"
		switch (0) {
#line 1319 "ListView.c"
			default:
			{
#line 292 "../src/panel/applets/budgie-menu/views/ListView.vala"
				break;
#line 1324 "ListView.c"
			}
		}
	}
}

/**
 * Launches the application in the given row.
 */
static void
application_list_view_on_row_activate (ApplicationListView* self,
                                       GtkListBoxRow* row)
{
	MenuButton* btn = NULL;
	GtkWidget* _tmp0_;
	MenuButton* _tmp1_;
	MenuButton* _tmp2_;
	BudgieApplication* _tmp3_;
	BudgieApplication* _tmp4_;
#line 299 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_if_fail (self != NULL);
#line 300 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (row == NULL) {
#line 301 "../src/panel/applets/budgie-menu/views/ListView.vala"
		return;
#line 1349 "ListView.c"
	}
#line 304 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp0_ = gtk_bin_get_child ((GtkBin*) row);
#line 304 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp1_ = _g_object_ref0 (IS_MENU_BUTTON (_tmp0_) ? ((MenuButton*) _tmp0_) : NULL);
#line 304 "../src/panel/applets/budgie-menu/views/ListView.vala"
	btn = _tmp1_;
#line 305 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp2_ = btn;
#line 305 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp3_ = menu_button_get_app (_tmp2_);
#line 305 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp4_ = _tmp3_;
#line 305 "../src/panel/applets/budgie-menu/views/ListView.vala"
	budgie_application_launch (_tmp4_);
#line 306 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_signal_emit_by_name ((ApplicationView*) self, "app-launched");
#line 299 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (btn);
#line 1369 "ListView.c"
}

/**
 * Provide category headers in the "All" category
 */
static void
application_list_view_do_list_header (ApplicationListView* self,
                                      GtkListBoxRow* before,
                                      GtkListBoxRow* after)
{
	MenuButton* child = NULL;
	gchar* prev = NULL;
	gchar* next = NULL;
	BudgieCategory* _tmp0_;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp18_ = FALSE;
#line 312 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_if_fail (self != NULL);
#line 313 "../src/panel/applets/budgie-menu/views/ListView.vala"
	child = NULL;
#line 314 "../src/panel/applets/budgie-menu/views/ListView.vala"
	prev = NULL;
#line 315 "../src/panel/applets/budgie-menu/views/ListView.vala"
	next = NULL;
#line 318 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp0_ = self->priv->current_category;
#line 318 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (_tmp0_ != NULL) {
#line 319 "../src/panel/applets/budgie-menu/views/ListView.vala"
		if (before != NULL) {
#line 320 "../src/panel/applets/budgie-menu/views/ListView.vala"
			gtk_list_box_row_set_header (before, NULL);
#line 1402 "ListView.c"
		}
#line 322 "../src/panel/applets/budgie-menu/views/ListView.vala"
		if (after != NULL) {
#line 323 "../src/panel/applets/budgie-menu/views/ListView.vala"
			gtk_list_box_row_set_header (after, NULL);
#line 1408 "ListView.c"
		}
#line 325 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_free0 (next);
#line 325 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_free0 (prev);
#line 325 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (child);
#line 325 "../src/panel/applets/budgie-menu/views/ListView.vala"
		return;
#line 1418 "ListView.c"
	}
#line 329 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (before != NULL) {
#line 1422 "ListView.c"
		GtkWidget* _tmp1_;
		MenuButton* _tmp2_;
		MenuButton* _tmp3_;
		BudgieCategory* _tmp4_;
		BudgieCategory* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 330 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp1_ = gtk_bin_get_child ((GtkBin*) before);
#line 330 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp2_ = _g_object_ref0 (IS_MENU_BUTTON (_tmp1_) ? ((MenuButton*) _tmp1_) : NULL);
#line 330 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (child);
#line 330 "../src/panel/applets/budgie-menu/views/ListView.vala"
		child = _tmp2_;
#line 331 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp3_ = child;
#line 331 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp4_ = menu_button_get_category (_tmp3_);
#line 331 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp5_ = _tmp4_;
#line 331 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp6_ = budgie_category_get_name (_tmp5_);
#line 331 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp7_ = _tmp6_;
#line 331 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp8_ = g_strdup (_tmp7_);
#line 331 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_free0 (prev);
#line 331 "../src/panel/applets/budgie-menu/views/ListView.vala"
		prev = _tmp8_;
#line 1455 "ListView.c"
	}
#line 334 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (after != NULL) {
#line 1459 "ListView.c"
		GtkWidget* _tmp9_;
		MenuButton* _tmp10_;
		MenuButton* _tmp11_;
		BudgieCategory* _tmp12_;
		BudgieCategory* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
#line 335 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp9_ = gtk_bin_get_child ((GtkBin*) after);
#line 335 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp10_ = _g_object_ref0 (IS_MENU_BUTTON (_tmp9_) ? ((MenuButton*) _tmp9_) : NULL);
#line 335 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (child);
#line 335 "../src/panel/applets/budgie-menu/views/ListView.vala"
		child = _tmp10_;
#line 336 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp11_ = child;
#line 336 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp12_ = menu_button_get_category (_tmp11_);
#line 336 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp13_ = _tmp12_;
#line 336 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp14_ = budgie_category_get_name (_tmp13_);
#line 336 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp15_ = _tmp14_;
#line 336 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp16_ = g_strdup (_tmp15_);
#line 336 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_free0 (next);
#line 336 "../src/panel/applets/budgie-menu/views/ListView.vala"
		next = _tmp16_;
#line 1492 "ListView.c"
	}
#line 340 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (before == NULL) {
#line 340 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp18_ = TRUE;
#line 1498 "ListView.c"
	} else {
#line 340 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp18_ = after == NULL;
#line 1502 "ListView.c"
	}
#line 340 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (_tmp18_) {
#line 340 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp17_ = TRUE;
#line 1508 "ListView.c"
	} else {
		const gchar* _tmp19_;
		const gchar* _tmp20_;
#line 340 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp19_ = prev;
#line 340 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp20_ = next;
#line 340 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp17_ = g_strcmp0 (_tmp19_, _tmp20_) != 0;
#line 1518 "ListView.c"
	}
#line 340 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (_tmp17_) {
#line 1522 "ListView.c"
		GtkLabel* label = NULL;
		const gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		GtkLabel* _tmp24_;
		GtkLabel* _tmp25_;
		GtkLabel* _tmp26_;
		GtkStyleContext* _tmp27_;
		GtkLabel* _tmp28_;
		GtkLabel* _tmp29_;
		GtkLabel* _tmp30_;
		GtkLabel* _tmp31_;
#line 341 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp21_ = prev;
#line 341 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp22_ = g_markup_printf_escaped ("<big>%s</big>", _tmp21_);
#line 341 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp23_ = _tmp22_;
#line 341 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp24_ = (GtkLabel*) gtk_label_new (_tmp23_);
#line 341 "../src/panel/applets/budgie-menu/views/ListView.vala"
		g_object_ref_sink (_tmp24_);
#line 341 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp25_ = _tmp24_;
#line 341 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_free0 (_tmp23_);
#line 341 "../src/panel/applets/budgie-menu/views/ListView.vala"
		label = _tmp25_;
#line 342 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp26_ = label;
#line 342 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp27_ = gtk_widget_get_style_context ((GtkWidget*) _tmp26_);
#line 342 "../src/panel/applets/budgie-menu/views/ListView.vala"
		gtk_style_context_add_class (_tmp27_, "dim-label");
#line 343 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp28_ = label;
#line 343 "../src/panel/applets/budgie-menu/views/ListView.vala"
		gtk_widget_set_halign ((GtkWidget*) _tmp28_, GTK_ALIGN_START);
#line 344 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp29_ = label;
#line 344 "../src/panel/applets/budgie-menu/views/ListView.vala"
		gtk_label_set_use_markup (_tmp29_, TRUE);
#line 345 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp30_ = label;
#line 345 "../src/panel/applets/budgie-menu/views/ListView.vala"
		gtk_list_box_row_set_header (before, (GtkWidget*) _tmp30_);
#line 346 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp31_ = label;
#line 346 "../src/panel/applets/budgie-menu/views/ListView.vala"
		g_object_set ((GtkWidget*) _tmp31_, "margin", 6, NULL);
#line 340 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (label);
#line 1575 "ListView.c"
	} else {
#line 348 "../src/panel/applets/budgie-menu/views/ListView.vala"
		gtk_list_box_row_set_header (before, NULL);
#line 1579 "ListView.c"
	}
#line 312 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_free0 (next);
#line 312 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_free0 (prev);
#line 312 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (child);
#line 1587 "ListView.c"
}

/**
 * Filter out results in the list according to whatever the current filter is,
 * i.e. group based or search based
 */
static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1359 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1360 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1360 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1361 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1362 "glib-2.0.vapi"
	result = _result_;
#line 1362 "glib-2.0.vapi"
	return result;
#line 1612 "ListView.c"
}

static gboolean
application_list_view_do_filter_list (ApplicationListView* self,
                                      GtkListBoxRow* row)
{
	MenuButton* child = NULL;
	GtkWidget* _tmp0_;
	MenuButton* _tmp1_;
	gchar* term = NULL;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	GtkBox* _tmp14_;
	BudgieCategory* _tmp15_;
	MenuButton* _tmp18_;
	BudgieCategory* _tmp19_;
	BudgieCategory* _tmp20_;
	BudgieCategory* _tmp21_;
	MenuButton* _tmp22_;
	gboolean result;
#line 356 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 356 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_val_if_fail (row != NULL, FALSE);
#line 357 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp0_ = gtk_bin_get_child ((GtkBin*) row);
#line 357 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp1_ = _g_object_ref0 (IS_MENU_BUTTON (_tmp0_) ? ((MenuButton*) _tmp0_) : NULL);
#line 357 "../src/panel/applets/budgie-menu/views/ListView.vala"
	child = _tmp1_;
#line 360 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp2_ = application_view_get_search_term ((ApplicationView*) self);
#line 360 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp3_ = _tmp2_;
#line 360 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp4_ = string_strip (_tmp3_);
#line 360 "../src/panel/applets/budgie-menu/views/ListView.vala"
	term = _tmp4_;
#line 361 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp5_ = term;
#line 361 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp6_ = strlen (_tmp5_);
#line 361 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp7_ = _tmp6_;
#line 361 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (_tmp7_ > 0) {
#line 1663 "ListView.c"
		GtkBox* _tmp8_;
		MenuButton* _tmp9_;
		BudgieRelevancyService* _tmp10_;
		MenuButton* _tmp11_;
		BudgieApplication* _tmp12_;
		BudgieApplication* _tmp13_;
#line 363 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp8_ = self->priv->categories;
#line 363 "../src/panel/applets/budgie-menu/views/ListView.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, FALSE);
#line 365 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp9_ = child;
#line 365 "../src/panel/applets/budgie-menu/views/ListView.vala"
		if (application_view_is_item_dupe ((ApplicationView*) self, _tmp9_)) {
#line 366 "../src/panel/applets/budgie-menu/views/ListView.vala"
			result = FALSE;
#line 366 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_g_free0 (term);
#line 366 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_g_object_unref0 (child);
#line 366 "../src/panel/applets/budgie-menu/views/ListView.vala"
			return result;
#line 1686 "ListView.c"
		}
#line 371 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp10_ = ((ApplicationView*) self)->relevancy_service;
#line 371 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp11_ = child;
#line 371 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp12_ = menu_button_get_app (_tmp11_);
#line 371 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp13_ = _tmp12_;
#line 371 "../src/panel/applets/budgie-menu/views/ListView.vala"
		result = budgie_relevancy_service_is_app_relevant (_tmp10_, _tmp13_);
#line 371 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_free0 (term);
#line 371 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (child);
#line 371 "../src/panel/applets/budgie-menu/views/ListView.vala"
		return result;
#line 1704 "ListView.c"
	}
#line 375 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp14_ = self->priv->categories;
#line 375 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp14_, TRUE);
#line 378 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp15_ = self->priv->current_category;
#line 378 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (_tmp15_ == NULL) {
#line 1714 "ListView.c"
		MenuButton* _tmp16_;
#line 381 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp16_ = child;
#line 381 "../src/panel/applets/budgie-menu/views/ListView.vala"
		if (menu_button_is_control_center_panel (_tmp16_)) {
#line 382 "../src/panel/applets/budgie-menu/views/ListView.vala"
			if (!self->priv->show_control_center_panels) {
#line 383 "../src/panel/applets/budgie-menu/views/ListView.vala"
				result = FALSE;
#line 383 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_g_free0 (term);
#line 383 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_g_object_unref0 (child);
#line 383 "../src/panel/applets/budgie-menu/views/ListView.vala"
				return result;
#line 1730 "ListView.c"
			}
		}
#line 387 "../src/panel/applets/budgie-menu/views/ListView.vala"
		if (self->priv->headers_visible) {
#line 389 "../src/panel/applets/budgie-menu/views/ListView.vala"
			result = TRUE;
#line 389 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_g_free0 (term);
#line 389 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_g_object_unref0 (child);
#line 389 "../src/panel/applets/budgie-menu/views/ListView.vala"
			return result;
#line 1743 "ListView.c"
		} else {
			MenuButton* _tmp17_;
#line 393 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_tmp17_ = child;
#line 393 "../src/panel/applets/budgie-menu/views/ListView.vala"
			result = !application_view_is_item_dupe ((ApplicationView*) self, _tmp17_);
#line 393 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_g_free0 (term);
#line 393 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_g_object_unref0 (child);
#line 393 "../src/panel/applets/budgie-menu/views/ListView.vala"
			return result;
#line 1756 "ListView.c"
		}
	}
#line 398 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp18_ = child;
#line 398 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp19_ = menu_button_get_category (_tmp18_);
#line 398 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp20_ = _tmp19_;
#line 398 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp21_ = self->priv->current_category;
#line 398 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (_tmp20_ != _tmp21_) {
#line 399 "../src/panel/applets/budgie-menu/views/ListView.vala"
		result = FALSE;
#line 399 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_free0 (term);
#line 399 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (child);
#line 399 "../src/panel/applets/budgie-menu/views/ListView.vala"
		return result;
#line 1777 "ListView.c"
	}
#line 403 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp22_ = child;
#line 403 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (menu_button_is_control_center_panel (_tmp22_)) {
#line 404 "../src/panel/applets/budgie-menu/views/ListView.vala"
		if (!self->priv->show_control_center_panels) {
#line 405 "../src/panel/applets/budgie-menu/views/ListView.vala"
			result = FALSE;
#line 405 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_g_free0 (term);
#line 405 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_g_object_unref0 (child);
#line 405 "../src/panel/applets/budgie-menu/views/ListView.vala"
			return result;
#line 1793 "ListView.c"
		}
	}
#line 411 "../src/panel/applets/budgie-menu/views/ListView.vala"
	result = TRUE;
#line 411 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_free0 (term);
#line 411 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (child);
#line 411 "../src/panel/applets/budgie-menu/views/ListView.vala"
	return result;
#line 1804 "ListView.c"
}

/**
 * Sorts two list items.
 *
 * If there is an active search, items will be sorted by how well they match the term.
 * Otherwise, they will be sorted alphebetically by their name.
 */
static gint
application_list_view_do_sort_list (ApplicationListView* self,
                                    GtkListBoxRow* row1,
                                    GtkListBoxRow* row2)
{
	MenuButton* child1 = NULL;
	GtkWidget* _tmp0_;
	MenuButton* _tmp1_;
	MenuButton* child2 = NULL;
	GtkWidget* _tmp2_;
	MenuButton* _tmp3_;
	gchar* term = NULL;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gchar* parentA = NULL;
	MenuButton* _tmp18_;
	BudgieCategory* _tmp19_;
	BudgieCategory* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* parentB = NULL;
	MenuButton* _tmp24_;
	BudgieCategory* _tmp25_;
	BudgieCategory* _tmp26_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	gchar* _tmp29_;
	gboolean _tmp30_ = FALSE;
	MenuButton* _tmp31_;
	BudgieCategory* _tmp32_;
	BudgieCategory* _tmp33_;
	MenuButton* _tmp34_;
	BudgieCategory* _tmp35_;
	BudgieCategory* _tmp36_;
	gchar* nameA = NULL;
	MenuButton* _tmp39_;
	BudgieApplication* _tmp40_;
	BudgieApplication* _tmp41_;
	const gchar* _tmp42_;
	const gchar* _tmp43_;
	gchar* _tmp44_;
	gchar* nameB = NULL;
	MenuButton* _tmp45_;
	BudgieApplication* _tmp46_;
	BudgieApplication* _tmp47_;
	const gchar* _tmp48_;
	const gchar* _tmp49_;
	gchar* _tmp50_;
	const gchar* _tmp51_;
	const gchar* _tmp52_;
	gint result;
#line 420 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 420 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_val_if_fail (row1 != NULL, 0);
#line 420 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_val_if_fail (row2 != NULL, 0);
#line 421 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp0_ = gtk_bin_get_child ((GtkBin*) row1);
#line 421 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp1_ = _g_object_ref0 (IS_MENU_BUTTON (_tmp0_) ? ((MenuButton*) _tmp0_) : NULL);
#line 421 "../src/panel/applets/budgie-menu/views/ListView.vala"
	child1 = _tmp1_;
#line 422 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp2_ = gtk_bin_get_child ((GtkBin*) row2);
#line 422 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp3_ = _g_object_ref0 (IS_MENU_BUTTON (_tmp2_) ? ((MenuButton*) _tmp2_) : NULL);
#line 422 "../src/panel/applets/budgie-menu/views/ListView.vala"
	child2 = _tmp3_;
#line 424 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp4_ = application_view_get_search_term ((ApplicationView*) self);
#line 424 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp5_ = _tmp4_;
#line 424 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp6_ = string_strip (_tmp5_);
#line 424 "../src/panel/applets/budgie-menu/views/ListView.vala"
	term = _tmp6_;
#line 427 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp7_ = term;
#line 427 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp8_ = strlen (_tmp7_);
#line 427 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp9_ = _tmp8_;
#line 427 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (_tmp9_ > 0) {
#line 1903 "ListView.c"
		gint sc1 = 0;
		BudgieRelevancyService* _tmp10_;
		MenuButton* _tmp11_;
		BudgieApplication* _tmp12_;
		BudgieApplication* _tmp13_;
		gint sc2 = 0;
		BudgieRelevancyService* _tmp14_;
		MenuButton* _tmp15_;
		BudgieApplication* _tmp16_;
		BudgieApplication* _tmp17_;
#line 429 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp10_ = ((ApplicationView*) self)->relevancy_service;
#line 429 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp11_ = child1;
#line 429 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp12_ = menu_button_get_app (_tmp11_);
#line 429 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp13_ = _tmp12_;
#line 429 "../src/panel/applets/budgie-menu/views/ListView.vala"
		sc1 = budgie_relevancy_service_get_score (_tmp10_, _tmp13_);
#line 430 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp14_ = ((ApplicationView*) self)->relevancy_service;
#line 430 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp15_ = child2;
#line 430 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp16_ = menu_button_get_app (_tmp15_);
#line 430 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp17_ = _tmp16_;
#line 430 "../src/panel/applets/budgie-menu/views/ListView.vala"
		sc2 = budgie_relevancy_service_get_score (_tmp14_, _tmp17_);
#line 433 "../src/panel/applets/budgie-menu/views/ListView.vala"
		if (sc1 < sc2) {
#line 434 "../src/panel/applets/budgie-menu/views/ListView.vala"
			result = -1;
#line 434 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_g_free0 (term);
#line 434 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_g_object_unref0 (child2);
#line 434 "../src/panel/applets/budgie-menu/views/ListView.vala"
			_g_object_unref0 (child1);
#line 434 "../src/panel/applets/budgie-menu/views/ListView.vala"
			return result;
#line 1946 "ListView.c"
		} else {
#line 435 "../src/panel/applets/budgie-menu/views/ListView.vala"
			if (sc1 > sc2) {
#line 436 "../src/panel/applets/budgie-menu/views/ListView.vala"
				result = 1;
#line 436 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_g_free0 (term);
#line 436 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_g_object_unref0 (child2);
#line 436 "../src/panel/applets/budgie-menu/views/ListView.vala"
				_g_object_unref0 (child1);
#line 436 "../src/panel/applets/budgie-menu/views/ListView.vala"
				return result;
#line 1960 "ListView.c"
			}
		}
#line 438 "../src/panel/applets/budgie-menu/views/ListView.vala"
		result = 0;
#line 438 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_free0 (term);
#line 438 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (child2);
#line 438 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (child1);
#line 438 "../src/panel/applets/budgie-menu/views/ListView.vala"
		return result;
#line 1973 "ListView.c"
	}
#line 442 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp18_ = child1;
#line 442 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp19_ = menu_button_get_category (_tmp18_);
#line 442 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp20_ = _tmp19_;
#line 442 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp21_ = budgie_category_get_name (_tmp20_);
#line 442 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp22_ = _tmp21_;
#line 442 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp23_ = budgie_relevancy_service_searchable_string (_tmp22_);
#line 442 "../src/panel/applets/budgie-menu/views/ListView.vala"
	parentA = _tmp23_;
#line 443 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp24_ = child2;
#line 443 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp25_ = menu_button_get_category (_tmp24_);
#line 443 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp26_ = _tmp25_;
#line 443 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp27_ = budgie_category_get_name (_tmp26_);
#line 443 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp28_ = _tmp27_;
#line 443 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp29_ = budgie_relevancy_service_searchable_string (_tmp28_);
#line 443 "../src/panel/applets/budgie-menu/views/ListView.vala"
	parentB = _tmp29_;
#line 444 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp31_ = child1;
#line 444 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp32_ = menu_button_get_category (_tmp31_);
#line 444 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp33_ = _tmp32_;
#line 444 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp34_ = child2;
#line 444 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp35_ = menu_button_get_category (_tmp34_);
#line 444 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp36_ = _tmp35_;
#line 444 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (_tmp33_ != _tmp36_) {
#line 444 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp30_ = self->priv->headers_visible;
#line 2019 "ListView.c"
	} else {
#line 444 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp30_ = FALSE;
#line 2023 "ListView.c"
	}
#line 444 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (_tmp30_) {
#line 2027 "ListView.c"
		const gchar* _tmp37_;
		const gchar* _tmp38_;
#line 445 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp37_ = parentA;
#line 445 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp38_ = parentB;
#line 445 "../src/panel/applets/budgie-menu/views/ListView.vala"
		result = g_utf8_collate (_tmp37_, _tmp38_);
#line 445 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_free0 (parentB);
#line 445 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_free0 (parentA);
#line 445 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_free0 (term);
#line 445 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (child2);
#line 445 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (child1);
#line 445 "../src/panel/applets/budgie-menu/views/ListView.vala"
		return result;
#line 2048 "ListView.c"
	}
#line 449 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp39_ = child1;
#line 449 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp40_ = menu_button_get_app (_tmp39_);
#line 449 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp41_ = _tmp40_;
#line 449 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp42_ = budgie_application_get_name (_tmp41_);
#line 449 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp43_ = _tmp42_;
#line 449 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp44_ = budgie_relevancy_service_searchable_string (_tmp43_);
#line 449 "../src/panel/applets/budgie-menu/views/ListView.vala"
	nameA = _tmp44_;
#line 450 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp45_ = child2;
#line 450 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp46_ = menu_button_get_app (_tmp45_);
#line 450 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp47_ = _tmp46_;
#line 450 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp48_ = budgie_application_get_name (_tmp47_);
#line 450 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp49_ = _tmp48_;
#line 450 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp50_ = budgie_relevancy_service_searchable_string (_tmp49_);
#line 450 "../src/panel/applets/budgie-menu/views/ListView.vala"
	nameB = _tmp50_;
#line 451 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp51_ = nameA;
#line 451 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp52_ = nameB;
#line 451 "../src/panel/applets/budgie-menu/views/ListView.vala"
	result = g_utf8_collate (_tmp51_, _tmp52_);
#line 451 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_free0 (nameB);
#line 451 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_free0 (nameA);
#line 451 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_free0 (parentB);
#line 451 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_free0 (parentA);
#line 451 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_free0 (term);
#line 451 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (child2);
#line 451 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (child1);
#line 451 "../src/panel/applets/budgie-menu/views/ListView.vala"
	return result;
#line 2100 "ListView.c"
}

/**
 * Change the current group/category
 */
static void
application_list_view_update_category (ApplicationListView* self,
                                       CategoryButton* btn)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 457 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_if_fail (self != NULL);
#line 457 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_if_fail (btn != NULL);
#line 458 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp0_ = gtk_toggle_button_get_active ((GtkToggleButton*) btn);
#line 458 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp1_ = _tmp0_;
#line 458 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (_tmp1_) {
#line 2122 "ListView.c"
		BudgieCategory* _tmp2_;
		BudgieCategory* _tmp3_;
		BudgieCategory* _tmp4_;
#line 459 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp2_ = category_button_get_category (btn);
#line 459 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp3_ = _tmp2_;
#line 459 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp4_ = _g_object_ref0 (_tmp3_);
#line 459 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (self->priv->current_category);
#line 459 "../src/panel/applets/budgie-menu/views/ListView.vala"
		self->priv->current_category = _tmp4_;
#line 460 "../src/panel/applets/budgie-menu/views/ListView.vala"
		application_view_invalidate ((ApplicationView*) self);
#line 2138 "ListView.c"
	}
}

/**
 * We need to make some changes to our display before we go showing ourselves
 * again! :)
 */
static void
application_list_view_real_on_show (ApplicationView* base)
{
	ApplicationListView * self;
	CategoryButton* _tmp0_;
	CategoryButton* _tmp1_;
	GtkListBox* _tmp2_;
	GtkScrolledWindow* _tmp3_;
	GtkAdjustment* _tmp4_;
	GtkScrolledWindow* _tmp5_;
	GtkAdjustment* _tmp6_;
	GtkBox* _tmp7_;
#line 468 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self = (ApplicationListView*) base;
#line 469 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp0_ = self->priv->all_categories;
#line 469 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, TRUE);
#line 470 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp1_ = self->priv->all_categories;
#line 470 "../src/panel/applets/budgie-menu/views/ListView.vala"
	application_list_view_update_category (self, _tmp1_);
#line 472 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp2_ = self->priv->applications;
#line 472 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_list_box_select_row (_tmp2_, NULL);
#line 473 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp3_ = self->priv->content_scroll;
#line 473 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp4_ = gtk_scrolled_window_get_vadjustment (_tmp3_);
#line 473 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_adjustment_set_value (_tmp4_, (gdouble) 0);
#line 474 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp5_ = self->priv->categories_scroll;
#line 474 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp6_ = gtk_scrolled_window_get_vadjustment (_tmp5_);
#line 474 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_adjustment_set_value (_tmp6_, (gdouble) 0);
#line 475 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp7_ = self->priv->categories;
#line 475 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, TRUE);
#line 477 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (!self->priv->compact_mode) {
#line 2190 "ListView.c"
		GtkScrolledWindow* _tmp8_;
#line 478 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp8_ = self->priv->categories_scroll;
#line 478 "../src/panel/applets/budgie-menu/views/ListView.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp8_);
#line 2196 "ListView.c"
	} else {
		GtkScrolledWindow* _tmp9_;
#line 480 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp9_ = self->priv->categories_scroll;
#line 480 "../src/panel/applets/budgie-menu/views/ListView.vala"
		gtk_widget_hide ((GtkWidget*) _tmp9_);
#line 2203 "ListView.c"
	}
}

GSettings*
application_list_view_get_settings (ApplicationListView* self)
{
	GSettings* result;
	GSettings* _tmp0_;
#line 27 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp0_ = self->priv->_settings;
#line 27 "../src/panel/applets/budgie-menu/views/ListView.vala"
	result = _tmp0_;
#line 27 "../src/panel/applets/budgie-menu/views/ListView.vala"
	return result;
#line 2220 "ListView.c"
}

static void
application_list_view_set_settings (ApplicationListView* self,
                                    GSettings* value)
{
	GSettings* old_value;
#line 27 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/panel/applets/budgie-menu/views/ListView.vala"
	old_value = application_list_view_get_settings (self);
#line 27 "../src/panel/applets/budgie-menu/views/ListView.vala"
	if (old_value != value) {
#line 2234 "ListView.c"
		GSettings* _tmp0_;
#line 27 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 27 "../src/panel/applets/budgie-menu/views/ListView.vala"
		_g_object_unref0 (self->priv->_settings);
#line 27 "../src/panel/applets/budgie-menu/views/ListView.vala"
		self->priv->_settings = _tmp0_;
#line 27 "../src/panel/applets/budgie-menu/views/ListView.vala"
		g_object_notify_by_pspec ((GObject *) self, application_list_view_properties[APPLICATION_LIST_VIEW_SETTINGS_PROPERTY]);
#line 2244 "ListView.c"
	}
}

static void
_application_list_view___lambda11_ (ApplicationListView* self)
{
	CategoryButton* _tmp0_;
#line 74 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp0_ = self->priv->all_categories;
#line 74 "../src/panel/applets/budgie-menu/views/ListView.vala"
	application_list_view_update_category (self, _tmp0_);
#line 2256 "ListView.c"
}

static void
__application_list_view___lambda11__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                               gpointer self)
{
#line 73 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_application_list_view___lambda11_ ((ApplicationListView*) self);
#line 2265 "ListView.c"
}

static void
_application_list_view_on_row_activate_gtk_list_box_row_activated (GtkListBox* _sender,
                                                                   GtkListBoxRow* row,
                                                                   gpointer self)
{
#line 88 "../src/panel/applets/budgie-menu/views/ListView.vala"
	application_list_view_on_row_activate ((ApplicationListView*) self, row);
#line 2275 "ListView.c"
}

static void
_application_list_view_on_settings_changed_g_settings_changed (GSettings* _sender,
                                                               const gchar* key,
                                                               gpointer self)
{
#line 109 "../src/panel/applets/budgie-menu/views/ListView.vala"
	application_list_view_on_settings_changed ((ApplicationListView*) self, key);
#line 2285 "ListView.c"
}

static gboolean
_application_list_view_do_filter_list_gtk_list_box_filter_func (GtkListBoxRow* row,
                                                                gpointer self)
{
	gboolean result;
	result = application_list_view_do_filter_list ((ApplicationListView*) self, row);
#line 116 "../src/panel/applets/budgie-menu/views/ListView.vala"
	return result;
#line 2296 "ListView.c"
}

static gint
_application_list_view_do_sort_list_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                            GtkListBoxRow* row2,
                                                            gpointer self)
{
	gint result;
	result = application_list_view_do_sort_list ((ApplicationListView*) self, row1, row2);
#line 117 "../src/panel/applets/budgie-menu/views/ListView.vala"
	return result;
#line 2308 "ListView.c"
}

static GObject *
application_list_view_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ApplicationListView * self;
	GSettings* _tmp0_;
	GtkBox* _tmp1_ = NULL;
	GtkScrolledWindow* _tmp2_ = NULL;
	GtkScrolledWindow* _tmp3_;
	GtkStyleContext* _tmp4_;
	GtkScrolledWindow* _tmp5_;
	GtkStyleContext* _tmp6_;
	GtkScrolledWindow* _tmp7_;
	GtkBox* _tmp8_;
	GtkScrolledWindow* _tmp9_;
	CategoryButton* _tmp10_;
	CategoryButton* _tmp11_;
	CategoryButton* _tmp12_;
	GtkBox* _tmp13_;
	CategoryButton* _tmp14_;
	GtkBox* right_layout = NULL;
	GtkBox* _tmp15_;
	GtkBox* _tmp16_;
	GtkListBox* _tmp17_ = NULL;
	GtkListBox* _tmp18_;
	GtkScrolledWindow* _tmp19_ = NULL;
	GtkScrolledWindow* _tmp20_;
	GtkScrolledWindow* _tmp21_;
	GtkListBox* _tmp22_;
	GtkBox* _tmp23_;
	GtkScrolledWindow* _tmp24_;
	GtkLabel* placeholder = NULL;
	gchar* _tmp25_;
	gchar* _tmp26_;
	GtkLabel* _tmp27_ = NULL;
	GtkLabel* _tmp28_;
	GtkLabel* _tmp29_;
	GtkStyleContext* _tmp30_;
	GtkLabel* _tmp31_;
	GtkListBox* _tmp32_;
	GtkLabel* _tmp33_;
	GSettings* _tmp34_;
	GtkListBox* _tmp35_;
	GtkListBox* _tmp36_;
#line 48 "../src/panel/applets/budgie-menu/views/ListView.vala"
	parent_class = G_OBJECT_CLASS (application_list_view_parent_class);
#line 48 "../src/panel/applets/budgie-menu/views/ListView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 48 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_APPLICATION_LIST_VIEW, ApplicationListView);
#line 49 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_widget_set_size_request ((GtkWidget*) self, 300, APPLICATION_LIST_VIEW_HEIGHT);
#line 50 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp0_ = self->priv->_settings;
#line 50 "../src/panel/applets/budgie-menu/views/ListView.vala"
	application_view_set_icon_size ((ApplicationView*) self, g_settings_get_int (_tmp0_, "menu-icons-size"));
#line 52 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp1_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 52 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp1_, 3);
#line 52 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp1_, 3);
#line 52 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_object_ref_sink (_tmp1_);
#line 52 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (self->priv->categories);
#line 52 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self->priv->categories = _tmp1_;
#line 57 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp2_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 57 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_scrolled_window_set_overlay_scrolling (_tmp2_, FALSE);
#line 57 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_scrolled_window_set_shadow_type (_tmp2_, GTK_SHADOW_NONE);
#line 57 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_object_set (_tmp2_, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
#line 57 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_object_set (_tmp2_, "vscrollbar-policy", GTK_POLICY_AUTOMATIC, NULL);
#line 57 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_scrolled_window_set_min_content_height (_tmp2_, APPLICATION_LIST_VIEW_HEIGHT);
#line 57 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_scrolled_window_set_propagate_natural_height (_tmp2_, TRUE);
#line 57 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_object_ref_sink (_tmp2_);
#line 57 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (self->priv->categories_scroll);
#line 57 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self->priv->categories_scroll = _tmp2_;
#line 65 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp3_ = self->priv->categories_scroll;
#line 65 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp4_ = gtk_widget_get_style_context ((GtkWidget*) _tmp3_);
#line 65 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_style_context_add_class (_tmp4_, "categories");
#line 66 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp5_ = self->priv->categories_scroll;
#line 66 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp6_ = gtk_widget_get_style_context ((GtkWidget*) _tmp5_);
#line 66 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_style_context_add_class (_tmp6_, "sidebar");
#line 67 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp7_ = self->priv->categories_scroll;
#line 67 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp8_ = self->priv->categories;
#line 67 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_container_add ((GtkContainer*) _tmp7_, (GtkWidget*) _tmp8_);
#line 68 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp9_ = self->priv->categories_scroll;
#line 68 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp9_, FALSE, FALSE, (guint) 0);
#line 71 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp10_ = category_button_new (NULL);
#line 71 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_object_ref_sink (_tmp10_);
#line 71 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (self->priv->all_categories);
#line 71 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self->priv->all_categories = _tmp10_;
#line 72 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp11_ = self->priv->all_categories;
#line 72 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_signal_connect_object ((GtkWidget*) _tmp11_, "enter-notify-event", (GCallback) _application_list_view_on_mouse_enter_gtk_widget_enter_notify_event, self, 0);
#line 73 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp12_ = self->priv->all_categories;
#line 73 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_signal_connect_object ((GtkToggleButton*) _tmp12_, "toggled", (GCallback) __application_list_view___lambda11__gtk_toggle_button_toggled, self, 0);
#line 76 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp13_ = self->priv->categories;
#line 76 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp14_ = self->priv->all_categories;
#line 76 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_box_pack_start (_tmp13_, (GtkWidget*) _tmp14_, FALSE, FALSE, (guint) 0);
#line 78 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp15_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 78 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_object_ref_sink (_tmp15_);
#line 78 "../src/panel/applets/budgie-menu/views/ListView.vala"
	right_layout = _tmp15_;
#line 79 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp16_ = right_layout;
#line 79 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp16_, TRUE, TRUE, (guint) 0);
#line 82 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp17_ = (GtkListBox*) gtk_list_box_new ();
#line 82 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_list_box_set_selection_mode (_tmp17_, GTK_SELECTION_NONE);
#line 82 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp17_, GTK_ALIGN_START);
#line 82 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_object_set ((GtkWidget*) _tmp17_, "height-request", APPLICATION_LIST_VIEW_HEIGHT, NULL);
#line 82 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_object_ref_sink (_tmp17_);
#line 82 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (self->priv->applications);
#line 82 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self->priv->applications = _tmp17_;
#line 88 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp18_ = self->priv->applications;
#line 88 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_signal_connect_object (_tmp18_, "row-activated", (GCallback) _application_list_view_on_row_activate_gtk_list_box_row_activated, self, 0);
#line 90 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp19_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 90 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_scrolled_window_set_overlay_scrolling (_tmp19_, TRUE);
#line 90 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_object_set (_tmp19_, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
#line 90 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_object_set (_tmp19_, "vscrollbar-policy", GTK_POLICY_AUTOMATIC, NULL);
#line 90 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_scrolled_window_set_min_content_height (_tmp19_, APPLICATION_LIST_VIEW_HEIGHT);
#line 90 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_object_ref_sink (_tmp19_);
#line 90 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (self->priv->content_scroll);
#line 90 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self->priv->content_scroll = _tmp19_;
#line 96 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp20_ = self->priv->content_scroll;
#line 96 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_scrolled_window_set_overlay_scrolling (_tmp20_, TRUE);
#line 97 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp21_ = self->priv->content_scroll;
#line 97 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp22_ = self->priv->applications;
#line 97 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_container_add ((GtkContainer*) _tmp21_, (GtkWidget*) _tmp22_);
#line 98 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp23_ = right_layout;
#line 98 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp24_ = self->priv->content_scroll;
#line 98 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_box_pack_start (_tmp23_, (GtkWidget*) _tmp24_, TRUE, TRUE, (guint) 0);
#line 101 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp25_ = g_strdup_printf ("<big>%s</big>", _ ("Sorry, no items found"));
#line 101 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp26_ = _tmp25_;
#line 101 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp27_ = (GtkLabel*) gtk_label_new (_tmp26_);
#line 101 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_label_set_use_markup (_tmp27_, TRUE);
#line 101 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_object_set ((GtkWidget*) _tmp27_, "margin", 6, NULL);
#line 101 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_object_ref_sink (_tmp27_);
#line 101 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp28_ = _tmp27_;
#line 101 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_free0 (_tmp26_);
#line 101 "../src/panel/applets/budgie-menu/views/ListView.vala"
	placeholder = _tmp28_;
#line 105 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp29_ = placeholder;
#line 105 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp30_ = gtk_widget_get_style_context ((GtkWidget*) _tmp29_);
#line 105 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_style_context_add_class (_tmp30_, "dim-label");
#line 106 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp31_ = placeholder;
#line 106 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_widget_show ((GtkWidget*) _tmp31_);
#line 107 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp32_ = self->priv->applications;
#line 107 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp33_ = placeholder;
#line 107 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_list_box_set_placeholder (_tmp32_, (GtkWidget*) _tmp33_);
#line 109 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp34_ = self->priv->_settings;
#line 109 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_signal_connect_object (_tmp34_, "changed", (GCallback) _application_list_view_on_settings_changed_g_settings_changed, self, 0);
#line 110 "../src/panel/applets/budgie-menu/views/ListView.vala"
	application_list_view_on_settings_changed (self, "menu-compact");
#line 111 "../src/panel/applets/budgie-menu/views/ListView.vala"
	application_list_view_on_settings_changed (self, "menu-headers");
#line 112 "../src/panel/applets/budgie-menu/views/ListView.vala"
	application_list_view_on_settings_changed (self, "menu-categories-hover");
#line 113 "../src/panel/applets/budgie-menu/views/ListView.vala"
	application_list_view_on_settings_changed (self, "menu-show-control-center-items");
#line 116 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp35_ = self->priv->applications;
#line 116 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_list_box_set_filter_func (_tmp35_, _application_list_view_do_filter_list_gtk_list_box_filter_func, g_object_ref (self), g_object_unref);
#line 117 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_tmp36_ = self->priv->applications;
#line 117 "../src/panel/applets/budgie-menu/views/ListView.vala"
	gtk_list_box_set_sort_func (_tmp36_, _application_list_view_do_sort_list_gtk_list_box_sort_func, g_object_ref (self), g_object_unref);
#line 48 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (placeholder);
#line 48 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (right_layout);
#line 48 "../src/panel/applets/budgie-menu/views/ListView.vala"
	return obj;
#line 2566 "ListView.c"
}

static void
application_list_view_class_init (ApplicationListViewClass * klass,
                                  gpointer klass_data)
{
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
	application_list_view_parent_class = g_type_class_peek_parent (klass);
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_type_class_adjust_private_offset (klass, &ApplicationListView_private_offset);
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
	((ApplicationViewClass *) klass)->refresh = (void (*) (ApplicationView*, BudgieAppIndex*)) application_list_view_real_refresh;
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
	((ApplicationViewClass *) klass)->invalidate = (void (*) (ApplicationView*)) application_list_view_real_invalidate;
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
	((ApplicationViewClass *) klass)->on_search_entry_activated = (void (*) (ApplicationView*)) application_list_view_real_on_search_entry_activated;
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
	((ApplicationViewClass *) klass)->on_show = (void (*) (ApplicationView*)) application_list_view_real_on_show;
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_application_list_view_get_property;
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_application_list_view_set_property;
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
	G_OBJECT_CLASS (klass)->constructor = application_list_view_constructor;
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
	G_OBJECT_CLASS (klass)->finalize = application_list_view_finalize;
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_LIST_VIEW_SETTINGS_PROPERTY, application_list_view_properties[APPLICATION_LIST_VIEW_SETTINGS_PROPERTY] = g_param_spec_object ("settings", "settings", "settings", g_settings_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 2595 "ListView.c"
}

static void
application_list_view_instance_init (ApplicationListView * self,
                                     gpointer klass)
{
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self->priv = application_list_view_get_instance_private (self);
#line 27 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self->priv->_settings = NULL;
#line 30 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self->priv->current_category = NULL;
#line 36 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self->priv->rollover_menus = TRUE;
#line 38 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_rec_mutex_init (&self->priv->__lock_reloading);
#line 38 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self->priv->reloading = FALSE;
#line 2614 "ListView.c"
}

static void
application_list_view_finalize (GObject * obj)
{
	ApplicationListView * self;
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_APPLICATION_LIST_VIEW, ApplicationListView);
#line 21 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (self->priv->categories);
#line 22 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (self->priv->applications);
#line 23 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (self->priv->categories_scroll);
#line 24 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (self->priv->content_scroll);
#line 25 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (self->priv->all_categories);
#line 27 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (self->priv->_settings);
#line 30 "../src/panel/applets/budgie-menu/views/ListView.vala"
	_g_object_unref0 (self->priv->current_category);
#line 38 "../src/panel/applets/budgie-menu/views/ListView.vala"
	g_rec_mutex_clear (&self->priv->__lock_reloading);
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
	G_OBJECT_CLASS (application_list_view_parent_class)->finalize (obj);
#line 2641 "ListView.c"
}

/**
 * Widget to display applications in a list.
 *
 * This shows a list of categories on the left, and all applications
 * on the right.
 */
GType
application_list_view_get_type (void)
{
	return application_list_view_type_id;
}

GType
application_list_view_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (ApplicationListViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) application_list_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ApplicationListView), 0, (GInstanceInitFunc) application_list_view_instance_init, NULL };
	application_list_view_type_id = g_type_module_register_type (module, TYPE_APPLICATION_VIEW, "ApplicationListView", &g_define_type_info, 0);
	ApplicationListView_private_offset = sizeof (ApplicationListViewPrivate);
	return application_list_view_type_id;
}

static void
_vala_application_list_view_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	ApplicationListView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_APPLICATION_LIST_VIEW, ApplicationListView);
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
	switch (property_id) {
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
		case APPLICATION_LIST_VIEW_SETTINGS_PROPERTY:
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
		g_value_set_object (value, application_list_view_get_settings (self));
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
		break;
#line 2681 "ListView.c"
		default:
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
		break;
#line 2687 "ListView.c"
	}
}

static void
_vala_application_list_view_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	ApplicationListView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_APPLICATION_LIST_VIEW, ApplicationListView);
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
	switch (property_id) {
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
		case APPLICATION_LIST_VIEW_SETTINGS_PROPERTY:
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
		application_list_view_set_settings (self, g_value_get_object (value));
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
		break;
#line 2707 "ListView.c"
		default:
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/panel/applets/budgie-menu/views/ListView.vala"
		break;
#line 2713 "ListView.c"
	}
}

