/* sound_input.c generated by valac 0.56.3, the Vala compiler
 * generated from sound_input.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include "org.buddiesofbudgie.budgie-desktop.raven.widget.SoundInput.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include "raven-plugin.h"
#include <glib-object.h>
#include <pulse/pulseaudio.h>
#include <gvc-mixer-control.h>
#include <gtk/gtk.h>
#include <gvc-mixer-stream.h>
#include <float.h>
#include <math.h>
#include <gvc-mixer-card.h>
#include <gvc-mixer-ui-device.h>
#include <pango/pango.h>
#include <libpeas/peas.h>

enum  {
	SOUND_INPUT_RAVEN_PLUGIN_0_PROPERTY,
	SOUND_INPUT_RAVEN_PLUGIN_NUM_PROPERTIES
};
static GParamSpec* sound_input_raven_plugin_properties[SOUND_INPUT_RAVEN_PLUGIN_NUM_PROPERTIES];
enum  {
	SOUND_INPUT_RAVEN_WIDGET_0_PROPERTY,
	SOUND_INPUT_RAVEN_WIDGET_NUM_PROPERTIES
};
static GParamSpec* sound_input_raven_widget_properties[SOUND_INPUT_RAVEN_WIDGET_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	SOUND_INPUT_RAVEN_WIDGET_DEVICES_STATE_CHANGED_SIGNAL,
	SOUND_INPUT_RAVEN_WIDGET_NUM_SIGNALS
};
static guint sound_input_raven_widget_signals[SOUND_INPUT_RAVEN_WIDGET_NUM_SIGNALS] = {0};

struct _SoundInputRavenWidgetPrivate {
	gulong scale_id;
	GvcMixerControl* mixer;
	GHashTable* derpers;
	GHashTable* devices;
	gulong primary_notify_id;
	GvcMixerStream* primary_stream;
	GtkBox* main_box;
	GtkListBox* devices_list;
	GtkBox* header;
	GtkButton* header_icon;
	GtkButton* header_reveal_button;
	GtkRevealer* content_revealer;
	GtkBox* content;
	GtkScale* volume_slider;
};

static gpointer sound_input_raven_plugin_parent_class = NULL;
static BudgieRavenPluginIface * sound_input_raven_plugin_budgie_raven_plugin_parent_iface = NULL;
static GType sound_input_raven_plugin_type_id = 0;
static gint SoundInputRavenWidget_private_offset;
static gpointer sound_input_raven_widget_parent_class = NULL;
static GType sound_input_raven_widget_type_id = 0;

static BudgieRavenWidget* sound_input_raven_plugin_real_new_widget_instance (BudgieRavenPlugin* base,
                                                                      const gchar* uuid,
                                                                      GSettings* settings);
static gboolean sound_input_raven_plugin_real_supports_settings (BudgieRavenPlugin* base);
static void __lambda4_ (SoundInputRavenWidget* self);
static void ___lambda4__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self);
static void __lambda5_ (SoundInputRavenWidget* self,
                 guint id);
static void ___lambda5__gvc_mixer_control_card_added (GvcMixerControl* _sender,
                                               guint id,
                                               gpointer self);
static void __lambda6_ (SoundInputRavenWidget* self,
                 guint id);
static void ___lambda6__gvc_mixer_control_card_removed (GvcMixerControl* _sender,
                                                 guint id,
                                                 gpointer self);
static void _g_free0_ (gpointer var);
static void _g_object_unref0_ (gpointer var);
static void sound_input_raven_widget_on_device_selected (SoundInputRavenWidget* self,
                                                  GtkListBoxRow* list_item);
static void _sound_input_raven_widget_on_device_selected_gtk_list_box_row_selected (GtkListBox* _sender,
                                                                             GtkListBoxRow* row,
                                                                             gpointer self);
static void sound_input_raven_widget_on_scale_change (SoundInputRavenWidget* self);
static void _sound_input_raven_widget_on_scale_change_gtk_range_value_changed (GtkRange* _sender,
                                                                        gpointer self);
static void __lambda7_ (SoundInputRavenWidget* self);
static void ___lambda7__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self);
static void sound_input_raven_widget_on_device_changed (SoundInputRavenWidget* self,
                                                 guint id);
static void _sound_input_raven_widget_on_device_changed_gvc_mixer_control_default_source_changed (GvcMixerControl* _sender,
                                                                                           guint id,
                                                                                           gpointer self);
static void sound_input_raven_widget_on_state_changed (SoundInputRavenWidget* self,
                                                guint id);
static void _sound_input_raven_widget_on_state_changed_gvc_mixer_control_state_changed (GvcMixerControl* _sender,
                                                                                 guint new_state,
                                                                                 gpointer self);
static void sound_input_raven_widget_on_device_added (SoundInputRavenWidget* self,
                                               guint id);
static void _sound_input_raven_widget_on_device_added_gvc_mixer_control_input_added (GvcMixerControl* _sender,
                                                                              guint id,
                                                                              gpointer self);
static void sound_input_raven_widget_on_device_removed (SoundInputRavenWidget* self,
                                                 guint id);
static void _sound_input_raven_widget_on_device_removed_gvc_mixer_control_input_removed (GvcMixerControl* _sender,
                                                                                  guint id,
                                                                                  gpointer self);
static void __lambda8_ (SoundInputRavenWidget* self,
                 GObject* n,
                 GParamSpec* p);
static void sound_input_raven_widget_update_volume (SoundInputRavenWidget* self);
static void ___lambda8__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static void sound_input_raven_widget_finalize (GObject * obj);

static BudgieRavenWidget*
sound_input_raven_plugin_real_new_widget_instance (BudgieRavenPlugin* base,
                                                   const gchar* uuid,
                                                   GSettings* settings)
{
	SoundInputRavenPlugin * self;
	SoundInputRavenWidget* _tmp0_;
	BudgieRavenWidget* result;
#line 13 "../src/raven/widgets/sound-input/sound_input.vala"
	self = (SoundInputRavenPlugin*) base;
#line 13 "../src/raven/widgets/sound-input/sound_input.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 14 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp0_ = sound_input_raven_widget_new (uuid, settings);
#line 14 "../src/raven/widgets/sound-input/sound_input.vala"
	g_object_ref_sink (_tmp0_);
#line 14 "../src/raven/widgets/sound-input/sound_input.vala"
	result = (BudgieRavenWidget*) _tmp0_;
#line 14 "../src/raven/widgets/sound-input/sound_input.vala"
	return result;
#line 156 "sound_input.c"
}

static gboolean
sound_input_raven_plugin_real_supports_settings (BudgieRavenPlugin* base)
{
	SoundInputRavenPlugin * self;
	gboolean result;
#line 17 "../src/raven/widgets/sound-input/sound_input.vala"
	self = (SoundInputRavenPlugin*) base;
#line 18 "../src/raven/widgets/sound-input/sound_input.vala"
	result = FALSE;
#line 18 "../src/raven/widgets/sound-input/sound_input.vala"
	return result;
#line 170 "sound_input.c"
}

SoundInputRavenPlugin*
sound_input_raven_plugin_construct (GType object_type)
{
	SoundInputRavenPlugin * self = NULL;
#line 12 "../src/raven/widgets/sound-input/sound_input.vala"
	self = (SoundInputRavenPlugin*) g_object_new (object_type, NULL);
#line 12 "../src/raven/widgets/sound-input/sound_input.vala"
	return self;
#line 181 "sound_input.c"
}

SoundInputRavenPlugin*
sound_input_raven_plugin_new (void)
{
#line 12 "../src/raven/widgets/sound-input/sound_input.vala"
	return sound_input_raven_plugin_construct (TYPE_SOUND_INPUT_RAVEN_PLUGIN);
#line 189 "sound_input.c"
}

static void
sound_input_raven_plugin_class_init (SoundInputRavenPluginClass * klass,
                                     gpointer klass_data)
{
#line 12 "../src/raven/widgets/sound-input/sound_input.vala"
	sound_input_raven_plugin_parent_class = g_type_class_peek_parent (klass);
#line 198 "sound_input.c"
}

static void
sound_input_raven_plugin_budgie_raven_plugin_interface_init (BudgieRavenPluginIface * iface,
                                                             gpointer iface_data)
{
#line 12 "../src/raven/widgets/sound-input/sound_input.vala"
	sound_input_raven_plugin_budgie_raven_plugin_parent_iface = g_type_interface_peek_parent (iface);
#line 12 "../src/raven/widgets/sound-input/sound_input.vala"
	iface->new_widget_instance = (BudgieRavenWidget* (*) (BudgieRavenPlugin*, const gchar*, GSettings*)) sound_input_raven_plugin_real_new_widget_instance;
#line 12 "../src/raven/widgets/sound-input/sound_input.vala"
	iface->supports_settings = (gboolean (*) (BudgieRavenPlugin*)) sound_input_raven_plugin_real_supports_settings;
#line 211 "sound_input.c"
}

static void
sound_input_raven_plugin_instance_init (SoundInputRavenPlugin * self,
                                        gpointer klass)
{
}

GType
sound_input_raven_plugin_get_type (void)
{
	return sound_input_raven_plugin_type_id;
}

GType
sound_input_raven_plugin_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (SoundInputRavenPluginClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_input_raven_plugin_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundInputRavenPlugin), 0, (GInstanceInitFunc) sound_input_raven_plugin_instance_init, NULL };
	static const GInterfaceInfo budgie_raven_plugin_info = { (GInterfaceInitFunc) sound_input_raven_plugin_budgie_raven_plugin_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	sound_input_raven_plugin_type_id = g_type_module_register_type (module, peas_extension_base_get_type (), "SoundInputRavenPlugin", &g_define_type_info, 0);
	g_type_module_add_interface (module, sound_input_raven_plugin_type_id, budgie_raven_plugin_get_type (), &budgie_raven_plugin_info);
	return sound_input_raven_plugin_type_id;
}

static inline gpointer
sound_input_raven_widget_get_instance_private (SoundInputRavenWidget* self)
{
	return G_STRUCT_MEMBER_P (self, SoundInputRavenWidget_private_offset);
}

static void
__lambda4_ (SoundInputRavenWidget* self)
{
	GvcMixerStream* _tmp0_;
#line 67 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp0_ = self->priv->primary_stream;
#line 67 "../src/raven/widgets/sound-input/sound_input.vala"
	if (_tmp0_ != NULL) {
#line 250 "sound_input.c"
		GvcMixerStream* _tmp1_;
		GvcMixerStream* _tmp2_;
#line 68 "../src/raven/widgets/sound-input/sound_input.vala"
		_tmp1_ = self->priv->primary_stream;
#line 68 "../src/raven/widgets/sound-input/sound_input.vala"
		_tmp2_ = self->priv->primary_stream;
#line 68 "../src/raven/widgets/sound-input/sound_input.vala"
		gvc_mixer_stream_change_is_muted (_tmp1_, !gvc_mixer_stream_get_is_muted (_tmp2_));
#line 259 "sound_input.c"
	}
}

static void
___lambda4__gtk_button_clicked (GtkButton* _sender,
                                gpointer self)
{
#line 66 "../src/raven/widgets/sound-input/sound_input.vala"
	__lambda4_ ((SoundInputRavenWidget*) self);
#line 269 "sound_input.c"
}

static void
__lambda5_ (SoundInputRavenWidget* self,
            guint id)
{
#line 88 "../src/raven/widgets/sound-input/sound_input.vala"
	g_signal_emit (self, sound_input_raven_widget_signals[SOUND_INPUT_RAVEN_WIDGET_DEVICES_STATE_CHANGED_SIGNAL], 0);
#line 278 "sound_input.c"
}

static void
___lambda5__gvc_mixer_control_card_added (GvcMixerControl* _sender,
                                          guint id,
                                          gpointer self)
{
#line 87 "../src/raven/widgets/sound-input/sound_input.vala"
	__lambda5_ ((SoundInputRavenWidget*) self, id);
#line 288 "sound_input.c"
}

static void
__lambda6_ (SoundInputRavenWidget* self,
            guint id)
{
#line 92 "../src/raven/widgets/sound-input/sound_input.vala"
	g_signal_emit (self, sound_input_raven_widget_signals[SOUND_INPUT_RAVEN_WIDGET_DEVICES_STATE_CHANGED_SIGNAL], 0);
#line 297 "sound_input.c"
}

static void
___lambda6__gvc_mixer_control_card_removed (GvcMixerControl* _sender,
                                            guint id,
                                            gpointer self)
{
#line 91 "../src/raven/widgets/sound-input/sound_input.vala"
	__lambda6_ ((SoundInputRavenWidget*) self, id);
#line 307 "sound_input.c"
}

static void
_g_free0_ (gpointer var)
{
#line 95 "../src/raven/widgets/sound-input/sound_input.vala"
	var = (g_free (var), NULL);
#line 315 "sound_input.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 98 "../src/raven/widgets/sound-input/sound_input.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 323 "sound_input.c"
}

static void
_sound_input_raven_widget_on_device_selected_gtk_list_box_row_selected (GtkListBox* _sender,
                                                                        GtkListBoxRow* row,
                                                                        gpointer self)
{
#line 107 "../src/raven/widgets/sound-input/sound_input.vala"
	sound_input_raven_widget_on_device_selected ((SoundInputRavenWidget*) self, row);
#line 333 "sound_input.c"
}

static void
_sound_input_raven_widget_on_scale_change_gtk_range_value_changed (GtkRange* _sender,
                                                                   gpointer self)
{
#line 111 "../src/raven/widgets/sound-input/sound_input.vala"
	sound_input_raven_widget_on_scale_change ((SoundInputRavenWidget*) self);
#line 342 "sound_input.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 122 "../src/raven/widgets/sound-input/sound_input.vala"
	return self ? g_object_ref (self) : NULL;
#line 350 "sound_input.c"
}

static void
__lambda7_ (SoundInputRavenWidget* self)
{
	GtkRevealer* _tmp0_;
	GtkRevealer* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GtkImage* image = NULL;
	GtkButton* _tmp4_;
	GtkWidget* _tmp5_;
	GtkImage* _tmp6_;
	GtkRevealer* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
#line 121 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp0_ = self->priv->content_revealer;
#line 121 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp1_ = self->priv->content_revealer;
#line 121 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp2_ = gtk_revealer_get_child_revealed (_tmp1_);
#line 121 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp3_ = _tmp2_;
#line 121 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_revealer_set_reveal_child (_tmp0_, !_tmp3_);
#line 122 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp4_ = self->priv->header_reveal_button;
#line 122 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp5_ = gtk_button_get_image (_tmp4_);
#line 122 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_image_get_type (), GtkImage));
#line 122 "../src/raven/widgets/sound-input/sound_input.vala"
	image = _tmp6_;
#line 123 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp7_ = self->priv->content_revealer;
#line 123 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp8_ = gtk_revealer_get_reveal_child (_tmp7_);
#line 123 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp9_ = _tmp8_;
#line 123 "../src/raven/widgets/sound-input/sound_input.vala"
	if (_tmp9_) {
#line 393 "sound_input.c"
		GtkImage* _tmp10_;
#line 124 "../src/raven/widgets/sound-input/sound_input.vala"
		_tmp10_ = image;
#line 124 "../src/raven/widgets/sound-input/sound_input.vala"
		gtk_image_set_from_icon_name (_tmp10_, "pan-down-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 399 "sound_input.c"
	} else {
		GtkImage* _tmp11_;
#line 126 "../src/raven/widgets/sound-input/sound_input.vala"
		_tmp11_ = image;
#line 126 "../src/raven/widgets/sound-input/sound_input.vala"
		gtk_image_set_from_icon_name (_tmp11_, "pan-end-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 406 "sound_input.c"
	}
#line 120 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_object_unref0 (image);
#line 410 "sound_input.c"
}

static void
___lambda7__gtk_button_clicked (GtkButton* _sender,
                                gpointer self)
{
#line 120 "../src/raven/widgets/sound-input/sound_input.vala"
	__lambda7_ ((SoundInputRavenWidget*) self);
#line 419 "sound_input.c"
}

static void
_sound_input_raven_widget_on_device_changed_gvc_mixer_control_default_source_changed (GvcMixerControl* _sender,
                                                                                      guint id,
                                                                                      gpointer self)
{
#line 131 "../src/raven/widgets/sound-input/sound_input.vala"
	sound_input_raven_widget_on_device_changed ((SoundInputRavenWidget*) self, id);
#line 429 "sound_input.c"
}

static void
_sound_input_raven_widget_on_state_changed_gvc_mixer_control_state_changed (GvcMixerControl* _sender,
                                                                            guint new_state,
                                                                            gpointer self)
{
#line 132 "../src/raven/widgets/sound-input/sound_input.vala"
	sound_input_raven_widget_on_state_changed ((SoundInputRavenWidget*) self, new_state);
#line 439 "sound_input.c"
}

static void
_sound_input_raven_widget_on_device_added_gvc_mixer_control_input_added (GvcMixerControl* _sender,
                                                                         guint id,
                                                                         gpointer self)
{
#line 133 "../src/raven/widgets/sound-input/sound_input.vala"
	sound_input_raven_widget_on_device_added ((SoundInputRavenWidget*) self, id);
#line 449 "sound_input.c"
}

static void
_sound_input_raven_widget_on_device_removed_gvc_mixer_control_input_removed (GvcMixerControl* _sender,
                                                                             guint id,
                                                                             gpointer self)
{
#line 134 "../src/raven/widgets/sound-input/sound_input.vala"
	sound_input_raven_widget_on_device_removed ((SoundInputRavenWidget*) self, id);
#line 459 "sound_input.c"
}

SoundInputRavenWidget*
sound_input_raven_widget_construct (GType object_type,
                                    const gchar* uuid,
                                    GSettings* settings)
{
	SoundInputRavenWidget * self = NULL;
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
	GtkBox* _tmp2_;
	GtkBox* _tmp3_;
	GtkStyleContext* _tmp4_;
	GtkBox* _tmp5_;
	GtkBox* _tmp6_;
	GtkButton* _tmp7_;
	GtkButton* _tmp8_;
	GtkStyleContext* _tmp9_;
	GtkButton* _tmp10_;
	GtkButton* _tmp11_;
	GtkButton* _tmp12_;
	GtkButton* _tmp13_;
	GtkButton* _tmp14_;
	GtkBox* _tmp15_;
	GtkButton* _tmp16_;
	GtkBox* _tmp17_;
	GtkBox* _tmp18_;
	GtkStyleContext* _tmp19_;
	GtkRevealer* _tmp20_;
	GtkRevealer* _tmp21_;
	GtkBox* _tmp22_;
	GtkBox* _tmp23_;
	GtkRevealer* _tmp24_;
	GtkStyleContext* _tmp25_;
	GvcMixerControl* _tmp26_;
	GvcMixerControl* _tmp27_;
	GvcMixerControl* _tmp28_;
	GHashFunc _tmp29_;
	GEqualFunc _tmp30_;
	GHashTable* _tmp31_;
	GHashTable* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	GHashTable* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	GHashFunc _tmp38_;
	GEqualFunc _tmp39_;
	GHashTable* _tmp40_;
	GtkListBox* _tmp41_;
	GtkListBox* _tmp42_;
	GtkStyleContext* _tmp43_;
	GtkListBox* _tmp44_;
	GtkStyleContext* _tmp45_;
	GtkListBox* _tmp46_;
	GtkListBox* _tmp47_;
	GtkScale* _tmp48_;
	GtkScale* _tmp49_;
	GtkScale* _tmp50_;
	GtkScale* _tmp51_;
	GtkBox* _tmp52_;
	GtkScale* _tmp53_;
	GtkButton* _tmp54_;
	GtkButton* _tmp55_;
	GtkStyleContext* _tmp56_;
	GtkButton* _tmp57_;
	GtkStyleContext* _tmp58_;
	GtkButton* _tmp59_;
	GtkButton* _tmp60_;
	GtkButton* _tmp61_;
	GtkBox* _tmp62_;
	GtkButton* _tmp63_;
	GvcMixerControl* _tmp64_;
	GvcMixerControl* _tmp65_;
	GvcMixerControl* _tmp66_;
	GvcMixerControl* _tmp67_;
	GtkBox* _tmp68_;
	GtkListBox* _tmp69_;
	GvcMixerControl* _tmp70_;
#line 50 "../src/raven/widgets/sound-input/sound_input.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 50 "../src/raven/widgets/sound-input/sound_input.vala"
	self = (SoundInputRavenWidget*) g_object_new (object_type, NULL);
#line 51 "../src/raven/widgets/sound-input/sound_input.vala"
	budgie_raven_widget_initialize ((BudgieRavenWidget*) self, uuid, settings);
#line 53 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp0_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 53 "../src/raven/widgets/sound-input/sound_input.vala"
	g_object_ref_sink (_tmp0_);
#line 53 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_object_unref0 (self->priv->main_box);
#line 53 "../src/raven/widgets/sound-input/sound_input.vala"
	self->priv->main_box = _tmp0_;
#line 54 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp1_ = self->priv->main_box;
#line 54 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp1_);
#line 56 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp2_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 56 "../src/raven/widgets/sound-input/sound_input.vala"
	g_object_ref_sink (_tmp2_);
#line 56 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_object_unref0 (self->priv->header);
#line 56 "../src/raven/widgets/sound-input/sound_input.vala"
	self->priv->header = _tmp2_;
#line 57 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp3_ = self->priv->header;
#line 57 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp4_ = gtk_widget_get_style_context ((GtkWidget*) _tmp3_);
#line 57 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_style_context_add_class (_tmp4_, "raven-header");
#line 58 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp5_ = self->priv->main_box;
#line 58 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp6_ = self->priv->header;
#line 58 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_container_add ((GtkContainer*) _tmp5_, (GtkWidget*) _tmp6_);
#line 60 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp7_ = (GtkButton*) gtk_button_new_from_icon_name ("microphone-sensitivity-muted-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 60 "../src/raven/widgets/sound-input/sound_input.vala"
	g_object_ref_sink (_tmp7_);
#line 60 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_object_unref0 (self->priv->header_icon);
#line 60 "../src/raven/widgets/sound-input/sound_input.vala"
	self->priv->header_icon = _tmp7_;
#line 61 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp8_ = self->priv->header_icon;
#line 61 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp9_ = gtk_widget_get_style_context ((GtkWidget*) _tmp8_);
#line 61 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_style_context_add_class (_tmp9_, "flat");
#line 62 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp10_ = self->priv->header_icon;
#line 62 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp10_, GTK_ALIGN_CENTER);
#line 63 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp11_ = self->priv->header_icon;
#line 63 "../src/raven/widgets/sound-input/sound_input.vala"
	g_object_set ((GtkWidget*) _tmp11_, "margin", 4, NULL);
#line 64 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp12_ = self->priv->header_icon;
#line 64 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp12_, 8);
#line 65 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp13_ = self->priv->header_icon;
#line 65 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp13_, 4);
#line 66 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp14_ = self->priv->header_icon;
#line 66 "../src/raven/widgets/sound-input/sound_input.vala"
	g_signal_connect_object (_tmp14_, "clicked", (GCallback) ___lambda4__gtk_button_clicked, self, 0);
#line 71 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp15_ = self->priv->header;
#line 71 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp16_ = self->priv->header_icon;
#line 71 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_container_add ((GtkContainer*) _tmp15_, (GtkWidget*) _tmp16_);
#line 73 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp17_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 73 "../src/raven/widgets/sound-input/sound_input.vala"
	g_object_ref_sink (_tmp17_);
#line 73 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_object_unref0 (self->priv->content);
#line 73 "../src/raven/widgets/sound-input/sound_input.vala"
	self->priv->content = _tmp17_;
#line 74 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp18_ = self->priv->content;
#line 74 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp19_ = gtk_widget_get_style_context ((GtkWidget*) _tmp18_);
#line 74 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_style_context_add_class (_tmp19_, "raven-background");
#line 76 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp20_ = (GtkRevealer*) gtk_revealer_new ();
#line 76 "../src/raven/widgets/sound-input/sound_input.vala"
	g_object_ref_sink (_tmp20_);
#line 76 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_object_unref0 (self->priv->content_revealer);
#line 76 "../src/raven/widgets/sound-input/sound_input.vala"
	self->priv->content_revealer = _tmp20_;
#line 77 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp21_ = self->priv->content_revealer;
#line 77 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp22_ = self->priv->content;
#line 77 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_container_add ((GtkContainer*) _tmp21_, (GtkWidget*) _tmp22_);
#line 78 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp23_ = self->priv->main_box;
#line 78 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp24_ = self->priv->content_revealer;
#line 78 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_container_add ((GtkContainer*) _tmp23_, (GtkWidget*) _tmp24_);
#line 80 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp25_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 80 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_style_context_add_class (_tmp25_, "audio-widget");
#line 85 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp26_ = gvc_mixer_control_new ("Budgie Volume Control");
#line 85 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_object_unref0 (self->priv->mixer);
#line 85 "../src/raven/widgets/sound-input/sound_input.vala"
	self->priv->mixer = _tmp26_;
#line 87 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp27_ = self->priv->mixer;
#line 87 "../src/raven/widgets/sound-input/sound_input.vala"
	g_signal_connect_object (_tmp27_, "card-added", (GCallback) ___lambda5__gvc_mixer_control_card_added, self, 0);
#line 91 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp28_ = self->priv->mixer;
#line 91 "../src/raven/widgets/sound-input/sound_input.vala"
	g_signal_connect_object (_tmp28_, "card-removed", (GCallback) ___lambda6__gvc_mixer_control_card_removed, self, 0);
#line 95 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp29_ = g_str_hash;
#line 95 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp30_ = g_str_equal;
#line 95 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp31_ = g_hash_table_new_full (_tmp29_, _tmp30_, _g_free0_, _g_free0_);
#line 95 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_hash_table_unref0 (self->priv->derpers);
#line 95 "../src/raven/widgets/sound-input/sound_input.vala"
	self->priv->derpers = _tmp31_;
#line 96 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp32_ = self->priv->derpers;
#line 96 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp33_ = g_strdup ("Vivaldi");
#line 96 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp34_ = g_strdup ("vivaldi");
#line 96 "../src/raven/widgets/sound-input/sound_input.vala"
	g_hash_table_insert (_tmp32_, _tmp33_, _tmp34_);
#line 97 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp35_ = self->priv->derpers;
#line 97 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp36_ = g_strdup ("Vivaldi Snapshot");
#line 97 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp37_ = g_strdup ("vivaldi-snapshot");
#line 97 "../src/raven/widgets/sound-input/sound_input.vala"
	g_hash_table_insert (_tmp35_, _tmp36_, _tmp37_);
#line 98 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp38_ = g_direct_hash;
#line 98 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp39_ = g_direct_equal;
#line 98 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp40_ = g_hash_table_new_full (_tmp38_, _tmp39_, NULL, _g_object_unref0_);
#line 98 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_hash_table_unref0 (self->priv->devices);
#line 98 "../src/raven/widgets/sound-input/sound_input.vala"
	self->priv->devices = _tmp40_;
#line 103 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp41_ = (GtkListBox*) gtk_list_box_new ();
#line 103 "../src/raven/widgets/sound-input/sound_input.vala"
	g_object_ref_sink (_tmp41_);
#line 103 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_object_unref0 (self->priv->devices_list);
#line 103 "../src/raven/widgets/sound-input/sound_input.vala"
	self->priv->devices_list = _tmp41_;
#line 104 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp42_ = self->priv->devices_list;
#line 104 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp43_ = gtk_widget_get_style_context ((GtkWidget*) _tmp42_);
#line 104 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_style_context_add_class (_tmp43_, "devices-list");
#line 105 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp44_ = self->priv->devices_list;
#line 105 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp45_ = gtk_widget_get_style_context ((GtkWidget*) _tmp44_);
#line 105 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_style_context_add_class (_tmp45_, "sound-devices");
#line 106 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp46_ = self->priv->devices_list;
#line 106 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_list_box_set_selection_mode (_tmp46_, GTK_SELECTION_SINGLE);
#line 107 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp47_ = self->priv->devices_list;
#line 107 "../src/raven/widgets/sound-input/sound_input.vala"
	g_signal_connect_object (_tmp47_, "row-selected", (GCallback) _sound_input_raven_widget_on_device_selected_gtk_list_box_row_selected, self, 0);
#line 109 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp48_ = (GtkScale*) gtk_scale_new_with_range (GTK_ORIENTATION_HORIZONTAL, (gdouble) 0, (gdouble) 100, (gdouble) 10);
#line 109 "../src/raven/widgets/sound-input/sound_input.vala"
	g_object_ref_sink (_tmp48_);
#line 109 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_object_unref0 (self->priv->volume_slider);
#line 109 "../src/raven/widgets/sound-input/sound_input.vala"
	self->priv->volume_slider = _tmp48_;
#line 110 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp49_ = self->priv->volume_slider;
#line 110 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_scale_set_draw_value (_tmp49_, FALSE);
#line 111 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp50_ = self->priv->volume_slider;
#line 111 "../src/raven/widgets/sound-input/sound_input.vala"
	g_signal_connect_object ((GtkRange*) _tmp50_, "value-changed", (GCallback) _sound_input_raven_widget_on_scale_change_gtk_range_value_changed, self, 0);
#line 112 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp51_ = self->priv->volume_slider;
#line 112 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp51_, TRUE);
#line 113 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp52_ = self->priv->header;
#line 113 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp53_ = self->priv->volume_slider;
#line 113 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_container_add ((GtkContainer*) _tmp52_, (GtkWidget*) _tmp53_);
#line 115 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp54_ = (GtkButton*) gtk_button_new_from_icon_name ("pan-end-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 115 "../src/raven/widgets/sound-input/sound_input.vala"
	g_object_ref_sink (_tmp54_);
#line 115 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_object_unref0 (self->priv->header_reveal_button);
#line 115 "../src/raven/widgets/sound-input/sound_input.vala"
	self->priv->header_reveal_button = _tmp54_;
#line 116 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp55_ = self->priv->header_reveal_button;
#line 116 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp56_ = gtk_widget_get_style_context ((GtkWidget*) _tmp55_);
#line 116 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_style_context_add_class (_tmp56_, "flat");
#line 117 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp57_ = self->priv->header_reveal_button;
#line 117 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp58_ = gtk_widget_get_style_context ((GtkWidget*) _tmp57_);
#line 117 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_style_context_add_class (_tmp58_, "expander-button");
#line 118 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp59_ = self->priv->header_reveal_button;
#line 118 "../src/raven/widgets/sound-input/sound_input.vala"
	g_object_set ((GtkWidget*) _tmp59_, "margin", 4, NULL);
#line 119 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp60_ = self->priv->header_reveal_button;
#line 119 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp60_, GTK_ALIGN_CENTER);
#line 120 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp61_ = self->priv->header_reveal_button;
#line 120 "../src/raven/widgets/sound-input/sound_input.vala"
	g_signal_connect_object (_tmp61_, "clicked", (GCallback) ___lambda7__gtk_button_clicked, self, 0);
#line 129 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp62_ = self->priv->header;
#line 129 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp63_ = self->priv->header_reveal_button;
#line 129 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_box_pack_end (_tmp62_, (GtkWidget*) _tmp63_, FALSE, FALSE, (guint) 0);
#line 131 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp64_ = self->priv->mixer;
#line 131 "../src/raven/widgets/sound-input/sound_input.vala"
	g_signal_connect_object (_tmp64_, "default-source-changed", (GCallback) _sound_input_raven_widget_on_device_changed_gvc_mixer_control_default_source_changed, self, 0);
#line 132 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp65_ = self->priv->mixer;
#line 132 "../src/raven/widgets/sound-input/sound_input.vala"
	g_signal_connect_object (_tmp65_, "state-changed", (GCallback) _sound_input_raven_widget_on_state_changed_gvc_mixer_control_state_changed, self, 0);
#line 133 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp66_ = self->priv->mixer;
#line 133 "../src/raven/widgets/sound-input/sound_input.vala"
	g_signal_connect_object (_tmp66_, "input-added", (GCallback) _sound_input_raven_widget_on_device_added_gvc_mixer_control_input_added, self, 0);
#line 134 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp67_ = self->priv->mixer;
#line 134 "../src/raven/widgets/sound-input/sound_input.vala"
	g_signal_connect_object (_tmp67_, "input-removed", (GCallback) _sound_input_raven_widget_on_device_removed_gvc_mixer_control_input_removed, self, 0);
#line 136 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp68_ = self->priv->content;
#line 136 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp69_ = self->priv->devices_list;
#line 136 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_box_pack_start (_tmp68_, (GtkWidget*) _tmp69_, FALSE, FALSE, (guint) 0);
#line 138 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp70_ = self->priv->mixer;
#line 138 "../src/raven/widgets/sound-input/sound_input.vala"
	gvc_mixer_control_open (_tmp70_);
#line 144 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 50 "../src/raven/widgets/sound-input/sound_input.vala"
	return self;
#line 827 "sound_input.c"
}

SoundInputRavenWidget*
sound_input_raven_widget_new (const gchar* uuid,
                              GSettings* settings)
{
#line 50 "../src/raven/widgets/sound-input/sound_input.vala"
	return sound_input_raven_widget_construct (TYPE_SOUND_INPUT_RAVEN_WIDGET, uuid, settings);
#line 836 "sound_input.c"
}

/**
 * has_devices will check if we have devices associated with this type
 */
gboolean
sound_input_raven_widget_has_devices (SoundInputRavenWidget* self)
{
	gboolean _tmp0_ = FALSE;
	GHashTable* _tmp1_;
	gboolean result;
#line 150 "../src/raven/widgets/sound-input/sound_input.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 151 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp1_ = self->priv->devices;
#line 151 "../src/raven/widgets/sound-input/sound_input.vala"
	if (g_hash_table_size (_tmp1_) != ((guint) 0)) {
#line 854 "sound_input.c"
		GvcMixerControl* _tmp2_;
		GSList* _tmp3_;
		GSList* _tmp4_;
#line 151 "../src/raven/widgets/sound-input/sound_input.vala"
		_tmp2_ = self->priv->mixer;
#line 151 "../src/raven/widgets/sound-input/sound_input.vala"
		_tmp3_ = gvc_mixer_control_get_cards (_tmp2_);
#line 151 "../src/raven/widgets/sound-input/sound_input.vala"
		_tmp4_ = _tmp3_;
#line 151 "../src/raven/widgets/sound-input/sound_input.vala"
		_tmp0_ = g_slist_length (_tmp4_) != ((guint) 0);
#line 151 "../src/raven/widgets/sound-input/sound_input.vala"
		(_tmp4_ == NULL) ? NULL : (_tmp4_ = (g_slist_free (_tmp4_), NULL));
#line 868 "sound_input.c"
	} else {
#line 151 "../src/raven/widgets/sound-input/sound_input.vala"
		_tmp0_ = FALSE;
#line 872 "sound_input.c"
	}
#line 151 "../src/raven/widgets/sound-input/sound_input.vala"
	result = _tmp0_;
#line 151 "../src/raven/widgets/sound-input/sound_input.vala"
	return result;
#line 878 "sound_input.c"
}

/**
 * on_device_added will handle when an input or output device has been added
 */
static void
sound_input_raven_widget_on_device_added (SoundInputRavenWidget* self,
                                          guint id)
{
	GHashTable* _tmp0_;
	GvcMixerUIDevice* device = NULL;
	GvcMixerControl* _tmp1_;
	GvcMixerUIDevice* _tmp2_;
	GvcMixerUIDevice* _tmp3_;
	GvcMixerUIDevice* _tmp4_;
	GvcMixerUIDevice* _tmp5_;
	void* _tmp6_;
	void* _tmp7_;
	GvcMixerCard* card = NULL;
	GvcMixerUIDevice* _tmp8_;
	void* _tmp9_;
	void* _tmp10_;
	GvcMixerCard* _tmp11_;
	GtkBox* box = NULL;
	GtkBox* _tmp12_;
	GtkBox* _tmp13_;
	GtkBox* _tmp14_;
	GtkBox* _tmp15_;
	GtkBox* _tmp16_;
	GtkLabel* label = NULL;
	GvcMixerUIDevice* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	GvcMixerCard* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	GtkLabel* _tmp27_ = NULL;
	GtkLabel* _tmp28_;
	GtkBox* _tmp29_;
	GtkLabel* _tmp30_;
	GtkListBoxRow* list_item = NULL;
	GtkListBoxRow* _tmp31_;
	GtkListBoxRow* _tmp32_;
	GtkBox* _tmp33_;
	GtkListBoxRow* _tmp34_;
	GtkListBox* _tmp35_;
	GtkListBoxRow* _tmp36_;
	GHashTable* _tmp37_;
	GtkListBoxRow* _tmp38_;
	GtkListBoxRow* _tmp39_;
	GtkListBoxRow* _tmp40_;
	GtkListBox* _tmp41_;
#line 157 "../src/raven/widgets/sound-input/sound_input.vala"
	g_return_if_fail (self != NULL);
#line 158 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp0_ = self->priv->devices;
#line 158 "../src/raven/widgets/sound-input/sound_input.vala"
	if (g_hash_table_contains (_tmp0_, (gpointer) ((guintptr) id))) {
#line 159 "../src/raven/widgets/sound-input/sound_input.vala"
		return;
#line 943 "sound_input.c"
	}
#line 162 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp1_ = self->priv->mixer;
#line 162 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp2_ = gvc_mixer_control_lookup_input_id (_tmp1_, id);
#line 162 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 162 "../src/raven/widgets/sound-input/sound_input.vala"
	device = _tmp3_;
#line 164 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp4_ = device;
#line 164 "../src/raven/widgets/sound-input/sound_input.vala"
	if (_tmp4_ == NULL) {
#line 165 "../src/raven/widgets/sound-input/sound_input.vala"
		_g_object_unref0 (device);
#line 165 "../src/raven/widgets/sound-input/sound_input.vala"
		return;
#line 961 "sound_input.c"
	}
#line 168 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp5_ = device;
#line 168 "../src/raven/widgets/sound-input/sound_input.vala"
	g_object_get (_tmp5_, "card", &_tmp6_, NULL);
#line 168 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp7_ = _tmp6_;
#line 168 "../src/raven/widgets/sound-input/sound_input.vala"
	if (_tmp7_ == NULL) {
#line 169 "../src/raven/widgets/sound-input/sound_input.vala"
		_g_object_unref0 (device);
#line 169 "../src/raven/widgets/sound-input/sound_input.vala"
		return;
#line 975 "sound_input.c"
	}
#line 172 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp8_ = device;
#line 172 "../src/raven/widgets/sound-input/sound_input.vala"
	g_object_get (_tmp8_, "card", &_tmp9_, NULL);
#line 172 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp10_ = _tmp9_;
#line 172 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp10_, gvc_mixer_card_get_type ()) ? ((GvcMixerCard*) _tmp10_) : NULL);
#line 172 "../src/raven/widgets/sound-input/sound_input.vala"
	card = _tmp11_;
#line 174 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp12_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 174 "../src/raven/widgets/sound-input/sound_input.vala"
	g_object_ref_sink (_tmp12_);
#line 174 "../src/raven/widgets/sound-input/sound_input.vala"
	box = _tmp12_;
#line 175 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp13_ = box;
#line 175 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp13_, 6);
#line 176 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp14_ = box;
#line 176 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp14_, 6);
#line 177 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp15_ = box;
#line 177 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp15_, 3);
#line 178 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp16_ = box;
#line 178 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp16_, 3);
#line 180 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp17_ = device;
#line 180 "../src/raven/widgets/sound-input/sound_input.vala"
	g_object_get (_tmp17_, "description", &_tmp18_, NULL);
#line 180 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp19_ = _tmp18_;
#line 180 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp20_ = _tmp19_;
#line 180 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp21_ = card;
#line 180 "../src/raven/widgets/sound-input/sound_input.vala"
	g_object_get (_tmp21_, "name", &_tmp22_, NULL);
#line 180 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp23_ = _tmp22_;
#line 180 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp24_ = _tmp23_;
#line 180 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp25_ = g_strdup_printf ("%s - %s", _tmp20_, _tmp24_);
#line 180 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp26_ = _tmp25_;
#line 180 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp27_ = (GtkLabel*) gtk_label_new (_tmp26_);
#line 180 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp27_, GTK_ALIGN_CENTER);
#line 180 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_label_set_xalign (_tmp27_, 0.0f);
#line 180 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_label_set_max_width_chars (_tmp27_, 1);
#line 180 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_label_set_ellipsize (_tmp27_, PANGO_ELLIPSIZE_END);
#line 180 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp27_, TRUE);
#line 180 "../src/raven/widgets/sound-input/sound_input.vala"
	g_object_ref_sink (_tmp27_);
#line 180 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp28_ = _tmp27_;
#line 180 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_free0 (_tmp26_);
#line 180 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_free0 (_tmp24_);
#line 180 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_free0 (_tmp20_);
#line 180 "../src/raven/widgets/sound-input/sound_input.vala"
	label = _tmp28_;
#line 187 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp29_ = box;
#line 187 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp30_ = label;
#line 187 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_box_pack_start (_tmp29_, (GtkWidget*) _tmp30_, FALSE, TRUE, (guint) 0);
#line 189 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp31_ = (GtkListBoxRow*) gtk_list_box_row_new ();
#line 189 "../src/raven/widgets/sound-input/sound_input.vala"
	g_object_ref_sink (_tmp31_);
#line 189 "../src/raven/widgets/sound-input/sound_input.vala"
	list_item = _tmp31_;
#line 190 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp32_ = list_item;
#line 190 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp33_ = box;
#line 190 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_container_add ((GtkContainer*) _tmp32_, (GtkWidget*) _tmp33_);
#line 192 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp34_ = list_item;
#line 192 "../src/raven/widgets/sound-input/sound_input.vala"
	g_object_set_data_full ((GObject*) _tmp34_, "device_id", (gpointer) ((guintptr) id), NULL);
#line 193 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp35_ = self->priv->devices_list;
#line 193 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp36_ = list_item;
#line 193 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_list_box_insert (_tmp35_, (GtkWidget*) _tmp36_, -1);
#line 195 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp37_ = self->priv->devices;
#line 195 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp38_ = list_item;
#line 195 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp39_ = _g_object_ref0 (_tmp38_);
#line 195 "../src/raven/widgets/sound-input/sound_input.vala"
	g_hash_table_insert (_tmp37_, (gpointer) ((guintptr) id), _tmp39_);
#line 196 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp40_ = list_item;
#line 196 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp40_);
#line 197 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp41_ = self->priv->devices_list;
#line 197 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp41_);
#line 199 "../src/raven/widgets/sound-input/sound_input.vala"
	g_signal_emit (self, sound_input_raven_widget_signals[SOUND_INPUT_RAVEN_WIDGET_DEVICES_STATE_CHANGED_SIGNAL], 0);
#line 157 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_object_unref0 (list_item);
#line 157 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_object_unref0 (label);
#line 157 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_object_unref0 (box);
#line 157 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_object_unref0 (card);
#line 157 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_object_unref0 (device);
#line 1109 "sound_input.c"
}

/**
 * on_device_changed will handle when a Gvc.MixerUIDevice has been changed
 */
static void
__lambda8_ (SoundInputRavenWidget* self,
            GObject* n,
            GParamSpec* p)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
#line 228 "../src/raven/widgets/sound-input/sound_input.vala"
	g_return_if_fail (n != NULL);
#line 228 "../src/raven/widgets/sound-input/sound_input.vala"
	g_return_if_fail (p != NULL);
#line 229 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp1_ = p->name;
#line 229 "../src/raven/widgets/sound-input/sound_input.vala"
	if (g_strcmp0 (_tmp1_, "volume") == 0) {
#line 229 "../src/raven/widgets/sound-input/sound_input.vala"
		_tmp0_ = TRUE;
#line 1132 "sound_input.c"
	} else {
		const gchar* _tmp2_;
#line 229 "../src/raven/widgets/sound-input/sound_input.vala"
		_tmp2_ = p->name;
#line 229 "../src/raven/widgets/sound-input/sound_input.vala"
		_tmp0_ = g_strcmp0 (_tmp2_, "is-muted") == 0;
#line 1139 "sound_input.c"
	}
#line 229 "../src/raven/widgets/sound-input/sound_input.vala"
	if (_tmp0_) {
#line 230 "../src/raven/widgets/sound-input/sound_input.vala"
		sound_input_raven_widget_update_volume (self);
#line 1145 "sound_input.c"
	}
}

static void
___lambda8__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
#line 228 "../src/raven/widgets/sound-input/sound_input.vala"
	__lambda8_ ((SoundInputRavenWidget*) self, _sender, pspec);
#line 1156 "sound_input.c"
}

static void
sound_input_raven_widget_on_device_changed (SoundInputRavenWidget* self,
                                            guint id)
{
	GvcMixerStream* stream = NULL;
	GvcMixerControl* _tmp0_;
	GvcMixerStream* _tmp1_;
	GvcMixerStream* _tmp2_;
	GvcMixerStream* _tmp3_;
	GvcMixerStream* _tmp4_;
	GvcMixerStream* _tmp5_;
	GvcMixerUIDevice* device = NULL;
	GvcMixerControl* _tmp6_;
	GvcMixerStream* _tmp7_;
	GvcMixerUIDevice* _tmp8_;
	GvcMixerUIDevice* _tmp9_;
	GtkListBoxRow* list_item = NULL;
	GHashTable* _tmp10_;
	GvcMixerUIDevice* _tmp11_;
	gconstpointer _tmp12_;
	GtkListBoxRow* _tmp13_;
	GtkListBoxRow* _tmp14_;
	GvcMixerStream* _tmp17_;
	GvcMixerStream* _tmp19_;
	gulong _tmp20_;
	GvcMixerStream* _tmp21_;
	GvcMixerStream* _tmp22_;
	GtkListBox* _tmp23_;
#line 205 "../src/raven/widgets/sound-input/sound_input.vala"
	g_return_if_fail (self != NULL);
#line 206 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp0_ = self->priv->mixer;
#line 206 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp1_ = gvc_mixer_control_get_default_source (_tmp0_);
#line 206 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 206 "../src/raven/widgets/sound-input/sound_input.vala"
	stream = _tmp2_;
#line 208 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp3_ = stream;
#line 208 "../src/raven/widgets/sound-input/sound_input.vala"
	if (_tmp3_ == NULL) {
#line 209 "../src/raven/widgets/sound-input/sound_input.vala"
		_g_object_unref0 (stream);
#line 209 "../src/raven/widgets/sound-input/sound_input.vala"
		return;
#line 1205 "sound_input.c"
	}
#line 212 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp4_ = stream;
#line 212 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp5_ = self->priv->primary_stream;
#line 212 "../src/raven/widgets/sound-input/sound_input.vala"
	if (_tmp4_ == _tmp5_) {
#line 213 "../src/raven/widgets/sound-input/sound_input.vala"
		_g_object_unref0 (stream);
#line 213 "../src/raven/widgets/sound-input/sound_input.vala"
		return;
#line 1217 "sound_input.c"
	}
#line 216 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp6_ = self->priv->mixer;
#line 216 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp7_ = stream;
#line 216 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp8_ = gvc_mixer_control_lookup_device_from_stream (_tmp6_, _tmp7_);
#line 216 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 216 "../src/raven/widgets/sound-input/sound_input.vala"
	device = _tmp9_;
#line 217 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp10_ = self->priv->devices;
#line 217 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp11_ = device;
#line 217 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp12_ = g_hash_table_lookup (_tmp10_, (gpointer) ((guintptr) gvc_mixer_ui_device_get_id (_tmp11_)));
#line 217 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp13_ = _g_object_ref0 ((GtkListBoxRow*) _tmp12_);
#line 217 "../src/raven/widgets/sound-input/sound_input.vala"
	list_item = _tmp13_;
#line 219 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp14_ = list_item;
#line 219 "../src/raven/widgets/sound-input/sound_input.vala"
	if (_tmp14_ != NULL) {
#line 1243 "sound_input.c"
		GtkListBox* _tmp15_;
		GtkListBoxRow* _tmp16_;
#line 220 "../src/raven/widgets/sound-input/sound_input.vala"
		_tmp15_ = self->priv->devices_list;
#line 220 "../src/raven/widgets/sound-input/sound_input.vala"
		_tmp16_ = list_item;
#line 220 "../src/raven/widgets/sound-input/sound_input.vala"
		gtk_list_box_select_row (_tmp15_, _tmp16_);
#line 1252 "sound_input.c"
	}
#line 223 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp17_ = self->priv->primary_stream;
#line 223 "../src/raven/widgets/sound-input/sound_input.vala"
	if (_tmp17_ != NULL) {
#line 1258 "sound_input.c"
		GvcMixerStream* _tmp18_;
#line 224 "../src/raven/widgets/sound-input/sound_input.vala"
		_tmp18_ = self->priv->primary_stream;
#line 224 "../src/raven/widgets/sound-input/sound_input.vala"
		g_signal_handler_disconnect ((GObject*) _tmp18_, self->priv->primary_notify_id);
#line 225 "../src/raven/widgets/sound-input/sound_input.vala"
		self->priv->primary_notify_id = (gulong) 0;
#line 1266 "sound_input.c"
	}
#line 228 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp19_ = stream;
#line 228 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp20_ = g_signal_connect_object ((GObject*) _tmp19_, "notify", (GCallback) ___lambda8__g_object_notify, self, 0);
#line 228 "../src/raven/widgets/sound-input/sound_input.vala"
	self->priv->primary_notify_id = _tmp20_;
#line 234 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp21_ = stream;
#line 234 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp22_ = _g_object_ref0 (_tmp21_);
#line 234 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_object_unref0 (self->priv->primary_stream);
#line 234 "../src/raven/widgets/sound-input/sound_input.vala"
	self->priv->primary_stream = _tmp22_;
#line 235 "../src/raven/widgets/sound-input/sound_input.vala"
	sound_input_raven_widget_update_volume (self);
#line 236 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp23_ = self->priv->devices_list;
#line 236 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp23_);
#line 237 "../src/raven/widgets/sound-input/sound_input.vala"
	g_signal_emit (self, sound_input_raven_widget_signals[SOUND_INPUT_RAVEN_WIDGET_DEVICES_STATE_CHANGED_SIGNAL], 0);
#line 205 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_object_unref0 (list_item);
#line 205 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_object_unref0 (device);
#line 205 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_object_unref0 (stream);
#line 1296 "sound_input.c"
}

/**
 * on_device_removed will handle when a Gvc.MixerUIDevice has been removed
 */
static void
sound_input_raven_widget_on_device_removed (SoundInputRavenWidget* self,
                                            guint id)
{
	GtkListBoxRow* list_item = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	GtkListBoxRow* _tmp2_;
	GtkListBoxRow* _tmp3_;
	GHashTable* _tmp4_;
	GtkListBoxRow* _tmp5_;
	GtkListBox* _tmp6_;
#line 243 "../src/raven/widgets/sound-input/sound_input.vala"
	g_return_if_fail (self != NULL);
#line 244 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp0_ = self->priv->devices;
#line 244 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, (gpointer) ((guintptr) id));
#line 244 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp2_ = _g_object_ref0 ((GtkListBoxRow*) _tmp1_);
#line 244 "../src/raven/widgets/sound-input/sound_input.vala"
	list_item = _tmp2_;
#line 246 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp3_ = list_item;
#line 246 "../src/raven/widgets/sound-input/sound_input.vala"
	if (_tmp3_ == NULL) {
#line 247 "../src/raven/widgets/sound-input/sound_input.vala"
		_g_object_unref0 (list_item);
#line 247 "../src/raven/widgets/sound-input/sound_input.vala"
		return;
#line 1332 "sound_input.c"
	}
#line 250 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp4_ = self->priv->devices;
#line 250 "../src/raven/widgets/sound-input/sound_input.vala"
	g_hash_table_steal (_tmp4_, (gpointer) ((guintptr) id));
#line 251 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp5_ = list_item;
#line 251 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp5_);
#line 252 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp6_ = self->priv->devices_list;
#line 252 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp6_);
#line 253 "../src/raven/widgets/sound-input/sound_input.vala"
	g_signal_emit (self, sound_input_raven_widget_signals[SOUND_INPUT_RAVEN_WIDGET_DEVICES_STATE_CHANGED_SIGNAL], 0);
#line 243 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_object_unref0 (list_item);
#line 1350 "sound_input.c"
}

/**
 * on_device_selected will handle when a checkbox related to an input or output device is selected
 */
static void
sound_input_raven_widget_on_device_selected (SoundInputRavenWidget* self,
                                             GtkListBoxRow* list_item)
{
	GtkListBox* _tmp0_;
	guint id = 0U;
	gconstpointer _tmp1_;
	GvcMixerUIDevice* device = NULL;
	GvcMixerControl* _tmp2_;
	GvcMixerUIDevice* _tmp3_;
	GvcMixerUIDevice* _tmp4_;
	GvcMixerUIDevice* _tmp5_;
	GtkListBox* _tmp8_;
#line 259 "../src/raven/widgets/sound-input/sound_input.vala"
	g_return_if_fail (self != NULL);
#line 260 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp0_ = self->priv->devices_list;
#line 260 "../src/raven/widgets/sound-input/sound_input.vala"
	g_signal_handlers_block_by_func ((void*) _tmp0_, (void*) sound_input_raven_widget_on_device_selected, self);
#line 261 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp1_ = g_object_get_data ((GObject*) list_item, "device_id");
#line 261 "../src/raven/widgets/sound-input/sound_input.vala"
	id = (guint) ((guintptr) _tmp1_);
#line 262 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp2_ = self->priv->mixer;
#line 262 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp3_ = gvc_mixer_control_lookup_input_id (_tmp2_, id);
#line 262 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 262 "../src/raven/widgets/sound-input/sound_input.vala"
	device = _tmp4_;
#line 264 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp5_ = device;
#line 264 "../src/raven/widgets/sound-input/sound_input.vala"
	if (_tmp5_ != NULL) {
#line 1391 "sound_input.c"
		GvcMixerControl* _tmp6_;
		GvcMixerUIDevice* _tmp7_;
#line 265 "../src/raven/widgets/sound-input/sound_input.vala"
		_tmp6_ = self->priv->mixer;
#line 265 "../src/raven/widgets/sound-input/sound_input.vala"
		_tmp7_ = device;
#line 265 "../src/raven/widgets/sound-input/sound_input.vala"
		gvc_mixer_control_change_input (_tmp6_, _tmp7_);
#line 1400 "sound_input.c"
	}
#line 267 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp8_ = self->priv->devices_list;
#line 267 "../src/raven/widgets/sound-input/sound_input.vala"
	g_signal_handlers_unblock_by_func ((void*) _tmp8_, (void*) sound_input_raven_widget_on_device_selected, self);
#line 259 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_object_unref0 (device);
#line 1408 "sound_input.c"
}

/**
 * When our volume slider has changed
 */
static void
sound_input_raven_widget_on_scale_change (SoundInputRavenWidget* self)
{
	gboolean _tmp0_ = FALSE;
	GvcMixerStream* _tmp1_;
	GvcMixerStream* _tmp3_;
	GtkScale* _tmp4_;
#line 273 "../src/raven/widgets/sound-input/sound_input.vala"
	g_return_if_fail (self != NULL);
#line 274 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp1_ = self->priv->primary_stream;
#line 274 "../src/raven/widgets/sound-input/sound_input.vala"
	if (_tmp1_ == NULL) {
#line 274 "../src/raven/widgets/sound-input/sound_input.vala"
		_tmp0_ = TRUE;
#line 1429 "sound_input.c"
	} else {
		GvcMixerStream* _tmp2_;
#line 274 "../src/raven/widgets/sound-input/sound_input.vala"
		_tmp2_ = self->priv->primary_stream;
#line 274 "../src/raven/widgets/sound-input/sound_input.vala"
		_tmp0_ = gvc_mixer_stream_get_is_muted (_tmp2_);
#line 1436 "sound_input.c"
	}
#line 274 "../src/raven/widgets/sound-input/sound_input.vala"
	if (_tmp0_) {
#line 275 "../src/raven/widgets/sound-input/sound_input.vala"
		return;
#line 1442 "sound_input.c"
	}
#line 278 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp3_ = self->priv->primary_stream;
#line 278 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp4_ = self->priv->volume_slider;
#line 278 "../src/raven/widgets/sound-input/sound_input.vala"
	if (gvc_mixer_stream_set_volume (_tmp3_, (guint32) gtk_range_get_value ((GtkRange*) _tmp4_))) {
#line 1450 "sound_input.c"
		GvcMixerStream* _tmp5_;
#line 279 "../src/raven/widgets/sound-input/sound_input.vala"
		_tmp5_ = self->priv->primary_stream;
#line 279 "../src/raven/widgets/sound-input/sound_input.vala"
		gvc_mixer_stream_push_volume (_tmp5_);
#line 1456 "sound_input.c"
	}
}

/**
 * on_state_changed will handle when the state of our Mixer or its streams have changed
 */
static void
sound_input_raven_widget_on_state_changed (SoundInputRavenWidget* self,
                                           guint id)
{
#line 286 "../src/raven/widgets/sound-input/sound_input.vala"
	g_return_if_fail (self != NULL);
#line 287 "../src/raven/widgets/sound-input/sound_input.vala"
	g_signal_emit (self, sound_input_raven_widget_signals[SOUND_INPUT_RAVEN_WIDGET_DEVICES_STATE_CHANGED_SIGNAL], 0);
#line 1471 "sound_input.c"
}

/**
 * update_volume will handle updating our volume slider and output header during device change
 */
static void
sound_input_raven_widget_update_volume (SoundInputRavenWidget* self)
{
	guint32 vol = 0U;
	GvcMixerStream* _tmp0_;
	gdouble vol_max = 0.0;
	GvcMixerControl* _tmp1_;
	gint n = 0;
	gchar* image_name = NULL;
	gchar* icon_prefix = NULL;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	GvcMixerStream* _tmp4_;
	GtkImage* header_image = NULL;
	GtkButton* _tmp9_;
	GtkWidget* _tmp10_;
	GtkImage* _tmp11_;
	GtkImage* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gdouble step_size = 0.0;
	GtkScale* _tmp18_;
	GtkScale* _tmp19_;
	GtkScale* _tmp20_;
#line 293 "../src/raven/widgets/sound-input/sound_input.vala"
	g_return_if_fail (self != NULL);
#line 294 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp0_ = self->priv->primary_stream;
#line 294 "../src/raven/widgets/sound-input/sound_input.vala"
	vol = gvc_mixer_stream_get_volume (_tmp0_);
#line 295 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp1_ = self->priv->mixer;
#line 295 "../src/raven/widgets/sound-input/sound_input.vala"
	vol_max = gvc_mixer_control_get_vol_max_norm (_tmp1_);
#line 299 "../src/raven/widgets/sound-input/sound_input.vala"
	n = ((gint) floor ((3 * vol) / vol_max)) + 1;
#line 303 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp2_ = g_strdup ("microphone-sensitivity");
#line 303 "../src/raven/widgets/sound-input/sound_input.vala"
	icon_prefix = _tmp2_;
#line 305 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp4_ = self->priv->primary_stream;
#line 305 "../src/raven/widgets/sound-input/sound_input.vala"
	if (gvc_mixer_stream_get_is_muted (_tmp4_)) {
#line 305 "../src/raven/widgets/sound-input/sound_input.vala"
		_tmp3_ = TRUE;
#line 1525 "sound_input.c"
	} else {
#line 305 "../src/raven/widgets/sound-input/sound_input.vala"
		_tmp3_ = vol <= ((guint32) 0);
#line 1529 "sound_input.c"
	}
#line 305 "../src/raven/widgets/sound-input/sound_input.vala"
	if (_tmp3_) {
#line 1533 "sound_input.c"
		gchar* _tmp5_;
#line 306 "../src/raven/widgets/sound-input/sound_input.vala"
		_tmp5_ = g_strdup ("muted");
#line 306 "../src/raven/widgets/sound-input/sound_input.vala"
		_g_free0 (image_name);
#line 306 "../src/raven/widgets/sound-input/sound_input.vala"
		image_name = _tmp5_;
#line 1541 "sound_input.c"
	} else {
#line 308 "../src/raven/widgets/sound-input/sound_input.vala"
		switch (n) {
#line 308 "../src/raven/widgets/sound-input/sound_input.vala"
			case 1:
#line 1547 "sound_input.c"
			{
				gchar* _tmp6_;
#line 310 "../src/raven/widgets/sound-input/sound_input.vala"
				_tmp6_ = g_strdup ("low");
#line 310 "../src/raven/widgets/sound-input/sound_input.vala"
				_g_free0 (image_name);
#line 310 "../src/raven/widgets/sound-input/sound_input.vala"
				image_name = _tmp6_;
#line 311 "../src/raven/widgets/sound-input/sound_input.vala"
				break;
#line 1558 "sound_input.c"
			}
#line 308 "../src/raven/widgets/sound-input/sound_input.vala"
			case 2:
#line 1562 "sound_input.c"
			{
				gchar* _tmp7_;
#line 313 "../src/raven/widgets/sound-input/sound_input.vala"
				_tmp7_ = g_strdup ("medium");
#line 313 "../src/raven/widgets/sound-input/sound_input.vala"
				_g_free0 (image_name);
#line 313 "../src/raven/widgets/sound-input/sound_input.vala"
				image_name = _tmp7_;
#line 314 "../src/raven/widgets/sound-input/sound_input.vala"
				break;
#line 1573 "sound_input.c"
			}
			default:
			{
				gchar* _tmp8_;
#line 316 "../src/raven/widgets/sound-input/sound_input.vala"
				_tmp8_ = g_strdup ("high");
#line 316 "../src/raven/widgets/sound-input/sound_input.vala"
				_g_free0 (image_name);
#line 316 "../src/raven/widgets/sound-input/sound_input.vala"
				image_name = _tmp8_;
#line 317 "../src/raven/widgets/sound-input/sound_input.vala"
				break;
#line 1586 "sound_input.c"
			}
		}
	}
#line 321 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp9_ = self->priv->header_icon;
#line 321 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp10_ = gtk_button_get_image (_tmp9_);
#line 321 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_image_get_type (), GtkImage));
#line 321 "../src/raven/widgets/sound-input/sound_input.vala"
	header_image = _tmp11_;
#line 322 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp12_ = header_image;
#line 322 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp13_ = icon_prefix;
#line 322 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp14_ = image_name;
#line 322 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp15_ = g_strdup_printf ("%s-%s-symbolic", _tmp13_, _tmp14_);
#line 322 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp16_ = _tmp15_;
#line 322 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_image_set_from_icon_name (_tmp12_, _tmp16_, (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 322 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_free0 (_tmp16_);
#line 325 "../src/raven/widgets/sound-input/sound_input.vala"
	step_size = vol_max / 20;
#line 327 "../src/raven/widgets/sound-input/sound_input.vala"
	if (self->priv->scale_id > ((gulong) 0)) {
#line 1616 "sound_input.c"
		GtkScale* _tmp17_;
#line 328 "../src/raven/widgets/sound-input/sound_input.vala"
		_tmp17_ = self->priv->volume_slider;
#line 328 "../src/raven/widgets/sound-input/sound_input.vala"
		g_signal_handler_block (_tmp17_, self->priv->scale_id);
#line 1622 "sound_input.c"
	}
#line 331 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp18_ = self->priv->volume_slider;
#line 331 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_range_set_increments ((GtkRange*) _tmp18_, step_size, step_size);
#line 332 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp19_ = self->priv->volume_slider;
#line 332 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_range_set_range ((GtkRange*) _tmp19_, (gdouble) 0, vol_max);
#line 333 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp20_ = self->priv->volume_slider;
#line 333 "../src/raven/widgets/sound-input/sound_input.vala"
	gtk_range_set_value ((GtkRange*) _tmp20_, (gdouble) vol);
#line 335 "../src/raven/widgets/sound-input/sound_input.vala"
	if (self->priv->scale_id > ((gulong) 0)) {
#line 1638 "sound_input.c"
		GtkScale* _tmp21_;
#line 336 "../src/raven/widgets/sound-input/sound_input.vala"
		_tmp21_ = self->priv->volume_slider;
#line 336 "../src/raven/widgets/sound-input/sound_input.vala"
		g_signal_handler_unblock (_tmp21_, self->priv->scale_id);
#line 1644 "sound_input.c"
	}
#line 293 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_object_unref0 (header_image);
#line 293 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_free0 (icon_prefix);
#line 293 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_free0 (image_name);
#line 1652 "sound_input.c"
}

static void
sound_input_raven_widget_class_init (SoundInputRavenWidgetClass * klass,
                                     gpointer klass_data)
{
#line 22 "../src/raven/widgets/sound-input/sound_input.vala"
	sound_input_raven_widget_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/raven/widgets/sound-input/sound_input.vala"
	g_type_class_adjust_private_offset (klass, &SoundInputRavenWidget_private_offset);
#line 22 "../src/raven/widgets/sound-input/sound_input.vala"
	G_OBJECT_CLASS (klass)->finalize = sound_input_raven_widget_finalize;
#line 1665 "sound_input.c"
	/**
	 * Signals
	 */
#line 22 "../src/raven/widgets/sound-input/sound_input.vala"
	sound_input_raven_widget_signals[SOUND_INPUT_RAVEN_WIDGET_DEVICES_STATE_CHANGED_SIGNAL] = g_signal_new ("devices-state-changed", TYPE_SOUND_INPUT_RAVEN_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1671 "sound_input.c"
}

static void
sound_input_raven_widget_instance_init (SoundInputRavenWidget * self,
                                        gpointer klass)
{
#line 22 "../src/raven/widgets/sound-input/sound_input.vala"
	self->priv = sound_input_raven_widget_get_instance_private (self);
#line 26 "../src/raven/widgets/sound-input/sound_input.vala"
	self->priv->scale_id = (gulong) 0;
#line 27 "../src/raven/widgets/sound-input/sound_input.vala"
	self->priv->mixer = NULL;
#line 30 "../src/raven/widgets/sound-input/sound_input.vala"
	self->priv->primary_notify_id = (gulong) 0;
#line 31 "../src/raven/widgets/sound-input/sound_input.vala"
	self->priv->primary_stream = NULL;
#line 41 "../src/raven/widgets/sound-input/sound_input.vala"
	self->priv->main_box = NULL;
#line 42 "../src/raven/widgets/sound-input/sound_input.vala"
	self->priv->devices_list = NULL;
#line 43 "../src/raven/widgets/sound-input/sound_input.vala"
	self->priv->header = NULL;
#line 44 "../src/raven/widgets/sound-input/sound_input.vala"
	self->priv->header_icon = NULL;
#line 45 "../src/raven/widgets/sound-input/sound_input.vala"
	self->priv->header_reveal_button = NULL;
#line 46 "../src/raven/widgets/sound-input/sound_input.vala"
	self->priv->content_revealer = NULL;
#line 47 "../src/raven/widgets/sound-input/sound_input.vala"
	self->priv->content = NULL;
#line 48 "../src/raven/widgets/sound-input/sound_input.vala"
	self->priv->volume_slider = NULL;
#line 1704 "sound_input.c"
}

static void
sound_input_raven_widget_finalize (GObject * obj)
{
	SoundInputRavenWidget * self;
#line 22 "../src/raven/widgets/sound-input/sound_input.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SOUND_INPUT_RAVEN_WIDGET, SoundInputRavenWidget);
#line 27 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_object_unref0 (self->priv->mixer);
#line 28 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_hash_table_unref0 (self->priv->derpers);
#line 29 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_hash_table_unref0 (self->priv->devices);
#line 31 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_object_unref0 (self->priv->primary_stream);
#line 41 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_object_unref0 (self->priv->main_box);
#line 42 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_object_unref0 (self->priv->devices_list);
#line 43 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_object_unref0 (self->priv->header);
#line 44 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_object_unref0 (self->priv->header_icon);
#line 45 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_object_unref0 (self->priv->header_reveal_button);
#line 46 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_object_unref0 (self->priv->content_revealer);
#line 47 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_object_unref0 (self->priv->content);
#line 48 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_object_unref0 (self->priv->volume_slider);
#line 22 "../src/raven/widgets/sound-input/sound_input.vala"
	G_OBJECT_CLASS (sound_input_raven_widget_parent_class)->finalize (obj);
#line 1739 "sound_input.c"
}

GType
sound_input_raven_widget_get_type (void)
{
	return sound_input_raven_widget_type_id;
}

GType
sound_input_raven_widget_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (SoundInputRavenWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_input_raven_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundInputRavenWidget), 0, (GInstanceInitFunc) sound_input_raven_widget_instance_init, NULL };
	sound_input_raven_widget_type_id = g_type_module_register_type (module, budgie_raven_widget_get_type (), "SoundInputRavenWidget", &g_define_type_info, 0);
	SoundInputRavenWidget_private_offset = sizeof (SoundInputRavenWidgetPrivate);
	return sound_input_raven_widget_type_id;
}

void
peas_register_types (GTypeModule* module)
{
	PeasObjectModule* objmodule = NULL;
	PeasObjectModule* _tmp0_;
#line 342 "../src/raven/widgets/sound-input/sound_input.vala"
	g_return_if_fail (module != NULL);
#line 342 "../src/raven/widgets/sound-input/sound_input.vala"
	sound_input_raven_plugin_register_type (module);
#line 342 "../src/raven/widgets/sound-input/sound_input.vala"
	sound_input_raven_widget_register_type (module);
#line 344 "../src/raven/widgets/sound-input/sound_input.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (module, peas_object_module_get_type ()) ? ((PeasObjectModule*) module) : NULL);
#line 344 "../src/raven/widgets/sound-input/sound_input.vala"
	objmodule = _tmp0_;
#line 345 "../src/raven/widgets/sound-input/sound_input.vala"
	peas_object_module_register_extension_type (objmodule, budgie_raven_plugin_get_type (), TYPE_SOUND_INPUT_RAVEN_PLUGIN);
#line 342 "../src/raven/widgets/sound-input/sound_input.vala"
	_g_object_unref0 (objmodule);
#line 1776 "sound_input.c"
}

